/* gcalc-solver.c generated by valac 0.56.18, the Vala compiler
 * generated from gcalc-solver.vala, do not modify */

/* gcalc-solver.vala
 *
 * Copyright (C) 2018  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include "gcalc/gcalc.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include "gcalc.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GCALC_SOLVER_0_PROPERTY,
	GCALC_SOLVER_EQUATION_MANAGER_PROPERTY,
	GCALC_SOLVER_NUM_PROPERTIES
};
static GParamSpec* gcalc_solver_properties[GCALC_SOLVER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GCalcSolverPrivate {
	GCalcMathEquationManager* _equation_manager;
};

static gint GCalcSolver_private_offset;
static gpointer gcalc_solver_parent_class = NULL;

static GObject * gcalc_solver_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void gcalc_solver_finalize (GObject * obj);
static GType gcalc_solver_get_type_once (void);
static void _vala_gcalc_solver_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_gcalc_solver_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
gcalc_solver_get_instance_private (GCalcSolver* self)
{
	return G_STRUCT_MEMBER_P (self, GCalcSolver_private_offset);
}

/**
   * Add an equation to {@link equation_manager}
   */
void
gcalc_solver_add_expression (GCalcSolver* self,
                             const gchar* exp,
                             GError** error)
{
	GCalcParser* p = NULL;
	GCalcParser* _tmp0_;
	GCalcMathEquationManager* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 50 "../gcalc/gcalc-solver.vala"
	g_return_if_fail (self != NULL);
#line 50 "../gcalc/gcalc-solver.vala"
	g_return_if_fail (exp != NULL);
#line 51 "../gcalc/gcalc-solver.vala"
	_tmp0_ = gcalc_parser_new ();
#line 51 "../gcalc/gcalc-solver.vala"
	p = _tmp0_;
#line 52 "../gcalc/gcalc-solver.vala"
	_tmp1_ = self->priv->_equation_manager;
#line 52 "../gcalc/gcalc-solver.vala"
	gcalc_parser_parse (p, exp, _tmp1_, &_inner_error0_);
#line 52 "../gcalc/gcalc-solver.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 52 "../gcalc/gcalc-solver.vala"
		g_propagate_error (error, _inner_error0_);
#line 52 "../gcalc/gcalc-solver.vala"
		_g_object_unref0 (p);
#line 52 "../gcalc/gcalc-solver.vala"
		return;
#line 113 "gcalc-solver.c"
	}
#line 50 "../gcalc/gcalc-solver.vala"
	_g_object_unref0 (p);
#line 117 "gcalc-solver.c"
}

/**
   * Add an equation to {@link equation_manager} and solves it
   */
GCalcMathResult*
gcalc_solver_solve (GCalcSolver* self,
                    const gchar* str,
                    GError** error)
{
	GCalcParser* p = NULL;
	GCalcParser* _tmp0_;
	GCalcMathResult* res = NULL;
	GError* _inner_error0_ = NULL;
	GCalcMathResult* result;
#line 57 "../gcalc/gcalc-solver.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "../gcalc/gcalc-solver.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 58 "../gcalc/gcalc-solver.vala"
	_tmp0_ = gcalc_parser_new ();
#line 58 "../gcalc/gcalc-solver.vala"
	p = _tmp0_;
#line 141 "gcalc-solver.c"
	{
		GCalcParser* _tmp1_;
		GCalcMathEquationManager* _tmp2_;
		GCalcMathEquationManager* _tmp3_;
		GCalcExpressionContainer* _tmp4_;
		GCalcExpressionContainer* _tmp5_;
		GCalcMathEquation* eq = NULL;
		GCalcMathEquationManager* _tmp7_;
		GCalcExpressionContainer* _tmp8_;
		GCalcExpressionContainer* _tmp9_;
		GObject* _tmp10_;
		GCalcMathEquation* _tmp11_;
		GCalcMathEquation* _tmp12_;
		GCalcMathEquation* _tmp14_;
		GCalcMathResult* _tmp15_;
#line 61 "../gcalc/gcalc-solver.vala"
		_tmp1_ = p;
#line 61 "../gcalc/gcalc-solver.vala"
		_tmp2_ = self->priv->_equation_manager;
#line 61 "../gcalc/gcalc-solver.vala"
		gcalc_parser_parse (_tmp1_, str, _tmp2_, &_inner_error0_);
#line 61 "../gcalc/gcalc-solver.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 165 "gcalc-solver.c"
			goto __catch0_g_error;
		}
#line 62 "../gcalc/gcalc-solver.vala"
		_tmp3_ = self->priv->_equation_manager;
#line 62 "../gcalc/gcalc-solver.vala"
		_tmp4_ = gcalc_math_equation_manager_get_equations (_tmp3_);
#line 62 "../gcalc/gcalc-solver.vala"
		_tmp5_ = _tmp4_;
#line 62 "../gcalc/gcalc-solver.vala"
		if (g_list_model_get_n_items ((GListModel*) _tmp5_) == ((guint) 0)) {
#line 176 "gcalc-solver.c"
			GCalcErrorResult* _tmp6_;
#line 63 "../gcalc/gcalc-solver.vala"
			_tmp6_ = gcalc_error_result_new (_ ("No equations found after parsing"));
#line 63 "../gcalc/gcalc-solver.vala"
			result = (GCalcMathResult*) _tmp6_;
#line 63 "../gcalc/gcalc-solver.vala"
			_g_object_unref0 (res);
#line 63 "../gcalc/gcalc-solver.vala"
			_g_object_unref0 (p);
#line 63 "../gcalc/gcalc-solver.vala"
			return result;
#line 188 "gcalc-solver.c"
		}
#line 65 "../gcalc/gcalc-solver.vala"
		_tmp7_ = self->priv->_equation_manager;
#line 65 "../gcalc/gcalc-solver.vala"
		_tmp8_ = gcalc_math_equation_manager_get_equations (_tmp7_);
#line 65 "../gcalc/gcalc-solver.vala"
		_tmp9_ = _tmp8_;
#line 65 "../gcalc/gcalc-solver.vala"
		_tmp10_ = g_list_model_get_item ((GListModel*) _tmp9_, (guint) 0);
#line 65 "../gcalc/gcalc-solver.vala"
		_tmp11_ = GCALC_IS_MATH_EQUATION (_tmp10_) ? ((GCalcMathEquation*) _tmp10_) : NULL;
#line 65 "../gcalc/gcalc-solver.vala"
		if (_tmp11_ == NULL) {
#line 65 "../gcalc/gcalc-solver.vala"
			_g_object_unref0 (_tmp10_);
#line 204 "gcalc-solver.c"
		}
#line 65 "../gcalc/gcalc-solver.vala"
		eq = _tmp11_;
#line 66 "../gcalc/gcalc-solver.vala"
		_tmp12_ = eq;
#line 66 "../gcalc/gcalc-solver.vala"
		if (_tmp12_ == NULL) {
#line 212 "gcalc-solver.c"
			GCalcErrorResult* _tmp13_;
#line 67 "../gcalc/gcalc-solver.vala"
			_tmp13_ = gcalc_error_result_new (_ ("No equations found after parsing"));
#line 67 "../gcalc/gcalc-solver.vala"
			result = (GCalcMathResult*) _tmp13_;
#line 67 "../gcalc/gcalc-solver.vala"
			_g_object_unref0 (eq);
#line 67 "../gcalc/gcalc-solver.vala"
			_g_object_unref0 (res);
#line 67 "../gcalc/gcalc-solver.vala"
			_g_object_unref0 (p);
#line 67 "../gcalc/gcalc-solver.vala"
			return result;
#line 226 "gcalc-solver.c"
		}
#line 69 "../gcalc/gcalc-solver.vala"
		_tmp14_ = eq;
#line 69 "../gcalc/gcalc-solver.vala"
		_tmp15_ = gcalc_math_expression_solve ((GCalcMathExpression*) _tmp14_);
#line 69 "../gcalc/gcalc-solver.vala"
		_g_object_unref0 (res);
#line 69 "../gcalc/gcalc-solver.vala"
		res = _tmp15_;
#line 60 "../gcalc/gcalc-solver.vala"
		_g_object_unref0 (eq);
#line 238 "gcalc-solver.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		GCalcErrorResult* _tmp20_;
#line 60 "../gcalc/gcalc-solver.vala"
		e = _inner_error0_;
#line 60 "../gcalc/gcalc-solver.vala"
		_inner_error0_ = NULL;
#line 71 "../gcalc/gcalc-solver.vala"
		_tmp16_ = e;
#line 71 "../gcalc/gcalc-solver.vala"
		_tmp17_ = _tmp16_->message;
#line 71 "../gcalc/gcalc-solver.vala"
		_tmp18_ = g_strdup_printf (_ ("Solving fails: %s"), _tmp17_);
#line 71 "../gcalc/gcalc-solver.vala"
		_tmp19_ = _tmp18_;
#line 71 "../gcalc/gcalc-solver.vala"
		_tmp20_ = gcalc_error_result_new (_tmp19_);
#line 71 "../gcalc/gcalc-solver.vala"
		_g_object_unref0 (res);
#line 71 "../gcalc/gcalc-solver.vala"
		res = (GCalcMathResult*) _tmp20_;
#line 71 "../gcalc/gcalc-solver.vala"
		_g_free0 (_tmp19_);
#line 60 "../gcalc/gcalc-solver.vala"
		_g_error_free0 (e);
#line 271 "gcalc-solver.c"
	}
	__finally0:
#line 60 "../gcalc/gcalc-solver.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 60 "../gcalc/gcalc-solver.vala"
		g_propagate_error (error, _inner_error0_);
#line 60 "../gcalc/gcalc-solver.vala"
		_g_object_unref0 (res);
#line 60 "../gcalc/gcalc-solver.vala"
		_g_object_unref0 (p);
#line 60 "../gcalc/gcalc-solver.vala"
		return NULL;
#line 284 "gcalc-solver.c"
	}
#line 73 "../gcalc/gcalc-solver.vala"
	result = res;
#line 73 "../gcalc/gcalc-solver.vala"
	_g_object_unref0 (p);
#line 73 "../gcalc/gcalc-solver.vala"
	return result;
#line 292 "gcalc-solver.c"
}

GCalcSolver*
gcalc_solver_construct (GType object_type)
{
	GCalcSolver * self = NULL;
#line 37 "../gcalc/gcalc-solver.vala"
	self = (GCalcSolver*) g_object_new (object_type, NULL);
#line 37 "../gcalc/gcalc-solver.vala"
	return self;
#line 303 "gcalc-solver.c"
}

GCalcSolver*
gcalc_solver_new (void)
{
#line 37 "../gcalc/gcalc-solver.vala"
	return gcalc_solver_construct (GCALC_TYPE_SOLVER);
#line 311 "gcalc-solver.c"
}

GCalcMathEquationManager*
gcalc_solver_get_equation_manager (GCalcSolver* self)
{
	GCalcMathEquationManager* result;
	GCalcMathEquationManager* _tmp0_;
#line 41 "../gcalc/gcalc-solver.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../gcalc/gcalc-solver.vala"
	_tmp0_ = self->priv->_equation_manager;
#line 41 "../gcalc/gcalc-solver.vala"
	result = _tmp0_;
#line 41 "../gcalc/gcalc-solver.vala"
	return result;
#line 327 "gcalc-solver.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../gcalc/gcalc-solver.vala"
	return self ? g_object_ref (self) : NULL;
#line 335 "gcalc-solver.c"
}

void
gcalc_solver_set_equation_manager (GCalcSolver* self,
                                   GCalcMathEquationManager* value)
{
	GCalcMathEquationManager* old_value;
#line 41 "../gcalc/gcalc-solver.vala"
	g_return_if_fail (self != NULL);
#line 41 "../gcalc/gcalc-solver.vala"
	old_value = gcalc_solver_get_equation_manager (self);
#line 41 "../gcalc/gcalc-solver.vala"
	if (old_value != value) {
#line 349 "gcalc-solver.c"
		GCalcMathEquationManager* _tmp0_;
#line 41 "../gcalc/gcalc-solver.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 41 "../gcalc/gcalc-solver.vala"
		_g_object_unref0 (self->priv->_equation_manager);
#line 41 "../gcalc/gcalc-solver.vala"
		self->priv->_equation_manager = _tmp0_;
#line 41 "../gcalc/gcalc-solver.vala"
		g_object_notify_by_pspec ((GObject *) self, gcalc_solver_properties[GCALC_SOLVER_EQUATION_MANAGER_PROPERTY]);
#line 359 "gcalc-solver.c"
	}
}

static GObject *
gcalc_solver_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GCalcSolver * self;
	GCalcEquationManager* _tmp0_;
	GCalcEquationManager* _tmp1_;
#line 43 "../gcalc/gcalc-solver.vala"
	parent_class = G_OBJECT_CLASS (gcalc_solver_parent_class);
#line 43 "../gcalc/gcalc-solver.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 43 "../gcalc/gcalc-solver.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GCALC_TYPE_SOLVER, GCalcSolver);
#line 44 "../gcalc/gcalc-solver.vala"
	_tmp0_ = gcalc_equation_manager_new ();
#line 44 "../gcalc/gcalc-solver.vala"
	_tmp1_ = _tmp0_;
#line 44 "../gcalc/gcalc-solver.vala"
	gcalc_solver_set_equation_manager (self, (GCalcMathEquationManager*) _tmp1_);
#line 44 "../gcalc/gcalc-solver.vala"
	_g_object_unref0 (_tmp1_);
#line 43 "../gcalc/gcalc-solver.vala"
	return obj;
#line 389 "gcalc-solver.c"
}

static void
gcalc_solver_class_init (GCalcSolverClass * klass,
                         gpointer klass_data)
{
#line 37 "../gcalc/gcalc-solver.vala"
	gcalc_solver_parent_class = g_type_class_peek_parent (klass);
#line 37 "../gcalc/gcalc-solver.vala"
	g_type_class_adjust_private_offset (klass, &GCalcSolver_private_offset);
#line 37 "../gcalc/gcalc-solver.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gcalc_solver_get_property;
#line 37 "../gcalc/gcalc-solver.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gcalc_solver_set_property;
#line 37 "../gcalc/gcalc-solver.vala"
	G_OBJECT_CLASS (klass)->constructor = gcalc_solver_constructor;
#line 37 "../gcalc/gcalc-solver.vala"
	G_OBJECT_CLASS (klass)->finalize = gcalc_solver_finalize;
#line 408 "gcalc-solver.c"
	/**
	   * An equation manager using to solve a given expression
	   */
#line 37 "../gcalc/gcalc-solver.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GCALC_SOLVER_EQUATION_MANAGER_PROPERTY, gcalc_solver_properties[GCALC_SOLVER_EQUATION_MANAGER_PROPERTY] = g_param_spec_object ("equation-manager", "equation-manager", "equation-manager", GCALC_TYPE_MATH_EQUATION_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 414 "gcalc-solver.c"
}

static void
gcalc_solver_instance_init (GCalcSolver * self,
                            gpointer klass)
{
#line 37 "../gcalc/gcalc-solver.vala"
	self->priv = gcalc_solver_get_instance_private (self);
#line 423 "gcalc-solver.c"
}

static void
gcalc_solver_finalize (GObject * obj)
{
	GCalcSolver * self;
#line 37 "../gcalc/gcalc-solver.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GCALC_TYPE_SOLVER, GCalcSolver);
#line 41 "../gcalc/gcalc-solver.vala"
	_g_object_unref0 (self->priv->_equation_manager);
#line 37 "../gcalc/gcalc-solver.vala"
	G_OBJECT_CLASS (gcalc_solver_parent_class)->finalize (obj);
#line 436 "gcalc-solver.c"
}

/**
 * Math expression solver.
 *
 * Add any required equations to {@link equation_manager} or use {@link add_expression},
 * then {@link solve} will add a new equation and returns the resulting
 * {@link MathResult}.
 * {{{
 *  var s = new Solver ();
 *  s.add ("x=3*5");
 *  var res = s.solve ("2*x+7*x^2");
 *  var c = (MathConstant) res;
 *  // Result will be 1605
 *  stdout.printf ("%g", c.real ());
 * }}}
 */
static GType
gcalc_solver_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GCalcSolverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gcalc_solver_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GCalcSolver), 0, (GInstanceInitFunc) gcalc_solver_instance_init, NULL };
	GType gcalc_solver_type_id;
	gcalc_solver_type_id = g_type_register_static (G_TYPE_OBJECT, "GCalcSolver", &g_define_type_info, 0);
	GCalcSolver_private_offset = g_type_add_instance_private (gcalc_solver_type_id, sizeof (GCalcSolverPrivate));
	return gcalc_solver_type_id;
}

GType
gcalc_solver_get_type (void)
{
	static volatile gsize gcalc_solver_type_id__once = 0;
	if (g_once_init_enter (&gcalc_solver_type_id__once)) {
		GType gcalc_solver_type_id;
		gcalc_solver_type_id = gcalc_solver_get_type_once ();
		g_once_init_leave (&gcalc_solver_type_id__once, gcalc_solver_type_id);
	}
	return gcalc_solver_type_id__once;
}

static void
_vala_gcalc_solver_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	GCalcSolver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GCALC_TYPE_SOLVER, GCalcSolver);
#line 37 "../gcalc/gcalc-solver.vala"
	switch (property_id) {
#line 37 "../gcalc/gcalc-solver.vala"
		case GCALC_SOLVER_EQUATION_MANAGER_PROPERTY:
#line 37 "../gcalc/gcalc-solver.vala"
		g_value_set_object (value, gcalc_solver_get_equation_manager (self));
#line 37 "../gcalc/gcalc-solver.vala"
		break;
#line 492 "gcalc-solver.c"
		default:
#line 37 "../gcalc/gcalc-solver.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "../gcalc/gcalc-solver.vala"
		break;
#line 498 "gcalc-solver.c"
	}
}

static void
_vala_gcalc_solver_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	GCalcSolver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GCALC_TYPE_SOLVER, GCalcSolver);
#line 37 "../gcalc/gcalc-solver.vala"
	switch (property_id) {
#line 37 "../gcalc/gcalc-solver.vala"
		case GCALC_SOLVER_EQUATION_MANAGER_PROPERTY:
#line 37 "../gcalc/gcalc-solver.vala"
		gcalc_solver_set_equation_manager (self, g_value_get_object (value));
#line 37 "../gcalc/gcalc-solver.vala"
		break;
#line 518 "gcalc-solver.c"
		default:
#line 37 "../gcalc/gcalc-solver.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "../gcalc/gcalc-solver.vala"
		break;
#line 524 "gcalc-solver.c"
	}
}

GQuark
gcalc_solver_error_quark (void)
{
#line 25 "../gcalc/gcalc-parser.vala"
	return g_quark_from_static_string ("gcalc-solver-error-quark");
#line 533 "gcalc-solver.c"
}

static GType
gcalc_solver_error_get_type_once (void)
{
	static const GEnumValue values[] = {{GCALC_SOLVER_ERROR_EXPRESSION_ERROR, "GCALC_SOLVER_ERROR_EXPRESSION_ERROR", "expression-error"}, {0, NULL, NULL}};
	GType gcalc_solver_error_type_id;
	gcalc_solver_error_type_id = g_enum_register_static ("GCalcSolverError", values);
	return gcalc_solver_error_type_id;
}

GType
gcalc_solver_error_get_type (void)
{
	static volatile gsize gcalc_solver_error_type_id__once = 0;
	if (g_once_init_enter (&gcalc_solver_error_type_id__once)) {
		GType gcalc_solver_error_type_id;
		gcalc_solver_error_type_id = gcalc_solver_error_get_type_once ();
		g_once_init_leave (&gcalc_solver_error_type_id__once, gcalc_solver_error_type_id);
	}
	return gcalc_solver_error_type_id__once;
}

