/* math-converter.c generated by valac 0.56.18, the Vala compiler
 * generated from math-converter.vala, do not modify */

/*
 * Copyright (C) 2008-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "calculator.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <langinfo.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MATH_CONVERTER (math_converter_get_type ())
#define MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_CONVERTER, MathConverter))
#define MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_CONVERTER, MathConverterClass))
#define IS_MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_CONVERTER))
#define IS_MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_CONVERTER))
#define MATH_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_CONVERTER, MathConverterClass))

typedef struct _MathConverter MathConverter;
typedef struct _MathConverterClass MathConverterClass;
typedef struct _MathConverterPrivate MathConverterPrivate;
enum  {
	MATH_CONVERTER_0_PROPERTY,
	MATH_CONVERTER_EQUATION_PROPERTY,
	MATH_CONVERTER_BOX_VISIBLE_PROPERTY,
	MATH_CONVERTER_NUM_PROPERTIES
};
static GParamSpec* math_converter_properties[MATH_CONVERTER_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gtk_expression_unref0(var) ((var == NULL) ? NULL : (var = (gtk_expression_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_GdkEventSequence_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEventSequence_free (var), NULL)))
#define _gdk_event_unref0(var) ((var == NULL) ? NULL : (var = (gdk_event_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
enum  {
	MATH_CONVERTER_CATEGORY_CHANGED_SIGNAL,
	MATH_CONVERTER_NUM_SIGNALS
};
static guint math_converter_signals[MATH_CONVERTER_NUM_SIGNALS] = {0};

struct _MathConverter {
	GtkBox parent_instance;
	MathConverterPrivate * priv;
};

struct _MathConverterClass {
	GtkBoxClass parent_class;
};

struct _MathConverterPrivate {
	MathEquation* _equation;
	gchar* category;
	Number* from_number;
	Number* to_number;
	GtkDropDown* category_combo;
	GtkDropDown* from_combo;
	GtkDropDown* to_combo;
	GtkTextView* from_entry;
	GtkTextView* to_entry;
	GtkPopoverMenu* from_context_menu;
	GtkPopoverMenu* to_context_menu;
	Serializer* fixed_serializer;
	GtkEventControllerKey* from_event_controller;
	GtkEventControllerKey* to_event_controller;
	gulong from_combobox_changed;
	gulong from_entry_changed;
	gulong to_entry_changed;
	GSimpleActionGroup* action_group;
	gboolean _box_visible;
};

struct _Block3Data {
	int _ref_count_;
	MathConverter* self;
	GdkClipboard* clipboard;
};

static gint MathConverter_private_offset;
static gpointer math_converter_parent_class = NULL;

VALA_EXTERN GType math_converter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MathConverter, g_object_unref)
static void math_converter_popup_cb (MathConverter* self,
                              GSimpleAction* action,
                              GVariant* param);
static void _math_converter_popup_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void math_converter_copy_cb (MathConverter* self,
                             GSimpleAction* action,
                             GVariant* param);
static void _math_converter_copy_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self);
static void math_converter_paste_cb (MathConverter* self,
                              GSimpleAction* action,
                              GVariant* param);
static void _math_converter_paste_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
VALA_EXTERN MathConverter* math_converter_new (MathEquation* equation);
VALA_EXTERN MathConverter* math_converter_construct (GType object_type,
                                         MathEquation* equation);
static void math_converter_construct_finish (MathConverter* self);
VALA_EXTERN MathEquation* math_converter_get_equation (MathConverter* self);
static void __lambda13_ (MathConverter* self);
static void math_converter_update_visibility (MathConverter* self);
static void ___lambda13__currency_manager_updated (CurrencyManager* _sender,
                                            const gchar* symbol,
                                            gpointer self);
static void math_converter_build_category_model (MathConverter* self);
static void math_converter_build_units_model (MathConverter* self);
static void math_converter_reformat_display (MathConverter* self);
static void _math_converter_reformat_display_math_equation_display_changed (MathEquation* _sender,
                                                                     Serializer* serializer,
                                                                     gpointer self);
static void math_converter_from_combobox_changed_cb (MathConverter* self);
static void _math_converter_from_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self);
static void math_converter_from_entry_changed_cb (MathConverter* self);
static void _math_converter_from_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                                    gpointer self);
static void math_converter_to_entry_changed_cb (MathConverter* self);
static void _math_converter_to_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                                  gpointer self);
VALA_EXTERN void math_converter_set_conversion (MathConverter* self,
                                    const gchar* unit_a,
                                    const gchar* unit_b);
static gint ____lambda14_ (MathConverter* self,
                    GObject* c1,
                    GObject* c2);
static gint _____lambda14__gcompare_data_func (gconstpointer a,
                                        gconstpointer b,
                                        gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN void math_converter_set_category (MathConverter* self,
                                  const gchar* category);
VALA_EXTERN gchar* math_converter_get_category (MathConverter* self);
static gboolean math_converter_set_active_unit (MathConverter* self,
                                         GtkDropDown* combo,
                                         Unit* unit);
static void math_converter_to_combobox_changed_cb (MathConverter* self);
VALA_EXTERN void math_converter_get_conversion (MathConverter* self,
                                    Unit** from_unit,
                                    Unit** to_unit);
VALA_EXTERN void math_converter_insert_text (MathConverter* self,
                                 const gchar* text);
VALA_EXTERN gboolean math_converter_get_box_visible (MathConverter* self);
VALA_EXTERN void math_converter_insert_numeric_point (MathConverter* self);
VALA_EXTERN void math_converter_clear (MathConverter* self);
VALA_EXTERN void math_converter_swap_units (MathConverter* self);
VALA_EXTERN void math_converter_backspace (MathConverter* self);
VALA_EXTERN void math_converter_paste (MathConverter* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda12_ (Block3Data* _data3_,
                  GObject* obj,
                  GAsyncResult* res);
static void math_converter_on_paste (MathConverter* self,
                              const gchar* text);
static void ___lambda12__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
VALA_EXTERN void math_converter_set_box_visible (MathConverter* self,
                                     gboolean value);
static void math_converter_category_combobox_changed_cb (MathConverter* self);
static void _math_converter_category_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static Number* math_converter_convert_equation (MathConverter* self,
                                         Number* x,
                                         Unit** source_unit,
                                         Unit** target_unit);
static void math_converter_save_selected_units (MathConverter* self);
static void _math_converter_to_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void math_converter_from_entry_focus_cb (MathConverter* self);
static Number* math_converter_get_number_from_string (MathConverter* self,
                                               const gchar* str);
static void _math_converter_from_entry_focus_cb_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void math_converter_to_entry_focus_cb (MathConverter* self);
static void _math_converter_to_entry_focus_cb_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static gboolean math_converter_key_press_cb (MathConverter* self,
                                      GtkEventControllerKey* controller,
                                      guint keyval,
                                      guint keycode,
                                      GdkModifierType mod_state);
static gboolean _math_converter_key_press_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                            guint keyval,
                                                                            guint keycode,
                                                                            GdkModifierType state,
                                                                            gpointer self);
static void math_converter_from_entry_click_cb (MathConverter* self,
                                         GtkGestureClick* gesture,
                                         gint n_click,
                                         gdouble x,
                                         gdouble y);
static void _vala_GdkEventSequence_free (GdkEventSequence* self);
static void math_converter_show_context_menu (MathConverter* self,
                                       GtkTextView* entry,
                                       gdouble x,
                                       gdouble y);
static void _math_converter_from_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                    gint n_press,
                                                                    gdouble x,
                                                                    gdouble y,
                                                                    gpointer self);
static void math_converter_to_entry_click_cb (MathConverter* self,
                                       GtkGestureClick* gesture,
                                       gint n_click,
                                       gdouble x,
                                       gdouble y);
static void _math_converter_to_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                  gint n_press,
                                                                  gdouble x,
                                                                  gdouble y,
                                                                  gpointer self);
VALA_EXTERN void math_converter_set_equation (MathConverter* self,
                                  MathEquation* value);
static GObject * math_converter_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _math_converter_construct_finish_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void math_converter_finalize (GObject * obj);
static GType math_converter_get_type_once (void);
static void _vala_math_converter_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_math_converter_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry MATH_CONVERTER_action_entries[3] = {{"popup", _math_converter_popup_cb_gsimple_action_activate_callback}, {"copy", _math_converter_copy_cb_gsimple_action_activate_callback}, {"paste", _math_converter_paste_cb_gsimple_action_activate_callback}};

static inline gpointer
math_converter_get_instance_private (MathConverter* self)
{
	return G_STRUCT_MEMBER_P (self, MathConverter_private_offset);
}

static void
_math_converter_popup_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 45 "../src/math-converter.vala"
	math_converter_popup_cb ((MathConverter*) self, action, parameter);
#line 297 "math-converter.c"
}

static void
_math_converter_copy_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                          GVariant* parameter,
                                                          gpointer self)
{
#line 45 "../src/math-converter.vala"
	math_converter_copy_cb ((MathConverter*) self, action, parameter);
#line 307 "math-converter.c"
}

static void
_math_converter_paste_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 45 "../src/math-converter.vala"
	math_converter_paste_cb ((MathConverter*) self, action, parameter);
#line 317 "math-converter.c"
}

MathConverter*
math_converter_construct (GType object_type,
                          MathEquation* equation)
{
	MathConverter * self = NULL;
#line 59 "../src/math-converter.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 61 "../src/math-converter.vala"
	self = (MathConverter*) g_object_new (object_type, "equation", equation, NULL);
#line 59 "../src/math-converter.vala"
	return self;
#line 331 "math-converter.c"
}

MathConverter*
math_converter_new (MathEquation* equation)
{
#line 59 "../src/math-converter.vala"
	return math_converter_construct (TYPE_MATH_CONVERTER, equation);
#line 339 "math-converter.c"
}

static void
__lambda13_ (MathConverter* self)
{
#line 77 "../src/math-converter.vala"
	math_converter_update_visibility (self);
#line 347 "math-converter.c"
}

static void
___lambda13__currency_manager_updated (CurrencyManager* _sender,
                                       const gchar* symbol,
                                       gpointer self)
{
#line 76 "../src/math-converter.vala"
	__lambda13_ ((MathConverter*) self);
#line 357 "math-converter.c"
}

static void
_math_converter_reformat_display_math_equation_display_changed (MathEquation* _sender,
                                                                Serializer* serializer,
                                                                gpointer self)
{
#line 84 "../src/math-converter.vala"
	math_converter_reformat_display ((MathConverter*) self);
#line 367 "math-converter.c"
}

static void
_math_converter_from_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self)
{
#line 85 "../src/math-converter.vala"
	math_converter_from_combobox_changed_cb ((MathConverter*) self);
#line 377 "math-converter.c"
}

static void
_math_converter_from_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                               gpointer self)
{
#line 92 "../src/math-converter.vala"
	math_converter_from_entry_changed_cb ((MathConverter*) self);
#line 386 "math-converter.c"
}

static void
_math_converter_to_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                             gpointer self)
{
#line 93 "../src/math-converter.vala"
	math_converter_to_entry_changed_cb ((MathConverter*) self);
#line 395 "math-converter.c"
}

static void
math_converter_construct_finish (MathConverter* self)
{
	MathEquation* _tmp0_;
	CurrencyManager* _tmp1_;
	CurrencyManager* _tmp2_;
	MathEquation* _tmp3_;
	GtkDropDown* _tmp4_;
	gulong _tmp5_;
	MathEquation* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	Serializer* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	GtkTextView* _tmp12_;
	GtkTextBuffer* _tmp13_;
	GtkTextBuffer* _tmp14_;
	MathEquation* _tmp15_;
	Serializer* _tmp16_;
	Serializer* _tmp17_;
	Number* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GtkTextView* _tmp21_;
	GtkTextBuffer* _tmp22_;
	GtkTextBuffer* _tmp23_;
	MathEquation* _tmp24_;
	Serializer* _tmp25_;
	Serializer* _tmp26_;
	Number* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GtkTextView* _tmp30_;
	GtkTextBuffer* _tmp31_;
	GtkTextBuffer* _tmp32_;
	gulong _tmp33_;
	GtkTextView* _tmp34_;
	GtkTextBuffer* _tmp35_;
	GtkTextBuffer* _tmp36_;
	gulong _tmp37_;
	MathEquation* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	MathEquation* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
#line 71 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/math-converter.vala"
	_tmp0_ = self->priv->_equation;
#line 73 "../src/math-converter.vala"
	if (_tmp0_ == NULL) {
#line 74 "../src/math-converter.vala"
		return;
#line 455 "math-converter.c"
	}
#line 76 "../src/math-converter.vala"
	_tmp1_ = currency_manager_get_default (TRUE, TRUE);
#line 76 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 76 "../src/math-converter.vala"
	g_signal_connect_object (_tmp2_, "updated", (GCallback) ___lambda13__currency_manager_updated, self, 0);
#line 76 "../src/math-converter.vala"
	_g_object_unref0 (_tmp2_);
#line 80 "../src/math-converter.vala"
	math_converter_build_category_model (self);
#line 81 "../src/math-converter.vala"
	math_converter_update_visibility (self);
#line 82 "../src/math-converter.vala"
	math_converter_build_units_model (self);
#line 84 "../src/math-converter.vala"
	_tmp3_ = self->priv->_equation;
#line 84 "../src/math-converter.vala"
	g_signal_connect_object (_tmp3_, "display-changed", (GCallback) _math_converter_reformat_display_math_equation_display_changed, self, 0);
#line 85 "../src/math-converter.vala"
	_tmp4_ = self->priv->from_combo;
#line 85 "../src/math-converter.vala"
	_tmp5_ = g_signal_connect_object ((GObject*) _tmp4_, "notify::selected", (GCallback) _math_converter_from_combobox_changed_cb_g_object_notify, self, 0);
#line 85 "../src/math-converter.vala"
	self->priv->from_combobox_changed = _tmp5_;
#line 86 "../src/math-converter.vala"
	_tmp6_ = self->priv->_equation;
#line 86 "../src/math-converter.vala"
	_tmp7_ = math_equation_get_accuracy (_tmp6_);
#line 86 "../src/math-converter.vala"
	_tmp8_ = _tmp7_;
#line 86 "../src/math-converter.vala"
	_tmp9_ = serializer_new (DISPLAY_FORMAT_FIXED, 10, _tmp8_);
#line 86 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->fixed_serializer);
#line 86 "../src/math-converter.vala"
	self->priv->fixed_serializer = _tmp9_;
#line 88 "../src/math-converter.vala"
	_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 88 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 88 "../src/math-converter.vala"
	self->priv->from_number = _tmp10_;
#line 89 "../src/math-converter.vala"
	_tmp11_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 89 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 89 "../src/math-converter.vala"
	self->priv->to_number = _tmp11_;
#line 90 "../src/math-converter.vala"
	_tmp12_ = self->priv->from_entry;
#line 90 "../src/math-converter.vala"
	_tmp13_ = gtk_text_view_get_buffer (_tmp12_);
#line 90 "../src/math-converter.vala"
	_tmp14_ = _tmp13_;
#line 90 "../src/math-converter.vala"
	_tmp15_ = self->priv->_equation;
#line 90 "../src/math-converter.vala"
	_tmp16_ = math_equation_get_serializer (_tmp15_);
#line 90 "../src/math-converter.vala"
	_tmp17_ = _tmp16_;
#line 90 "../src/math-converter.vala"
	_tmp18_ = self->priv->from_number;
#line 90 "../src/math-converter.vala"
	_tmp19_ = serializer_to_string (_tmp17_, _tmp18_);
#line 90 "../src/math-converter.vala"
	_tmp20_ = _tmp19_;
#line 90 "../src/math-converter.vala"
	g_object_set (_tmp14_, "text", _tmp20_, NULL);
#line 90 "../src/math-converter.vala"
	_g_free0 (_tmp20_);
#line 91 "../src/math-converter.vala"
	_tmp21_ = self->priv->to_entry;
#line 91 "../src/math-converter.vala"
	_tmp22_ = gtk_text_view_get_buffer (_tmp21_);
#line 91 "../src/math-converter.vala"
	_tmp23_ = _tmp22_;
#line 91 "../src/math-converter.vala"
	_tmp24_ = self->priv->_equation;
#line 91 "../src/math-converter.vala"
	_tmp25_ = math_equation_get_serializer (_tmp24_);
#line 91 "../src/math-converter.vala"
	_tmp26_ = _tmp25_;
#line 91 "../src/math-converter.vala"
	_tmp27_ = self->priv->to_number;
#line 91 "../src/math-converter.vala"
	_tmp28_ = serializer_to_string (_tmp26_, _tmp27_);
#line 91 "../src/math-converter.vala"
	_tmp29_ = _tmp28_;
#line 91 "../src/math-converter.vala"
	g_object_set (_tmp23_, "text", _tmp29_, NULL);
#line 91 "../src/math-converter.vala"
	_g_free0 (_tmp29_);
#line 92 "../src/math-converter.vala"
	_tmp30_ = self->priv->from_entry;
#line 92 "../src/math-converter.vala"
	_tmp31_ = gtk_text_view_get_buffer (_tmp30_);
#line 92 "../src/math-converter.vala"
	_tmp32_ = _tmp31_;
#line 92 "../src/math-converter.vala"
	_tmp33_ = g_signal_connect_object (_tmp32_, "changed", (GCallback) _math_converter_from_entry_changed_cb_gtk_text_buffer_changed, self, 0);
#line 92 "../src/math-converter.vala"
	self->priv->from_entry_changed = _tmp33_;
#line 93 "../src/math-converter.vala"
	_tmp34_ = self->priv->to_entry;
#line 93 "../src/math-converter.vala"
	_tmp35_ = gtk_text_view_get_buffer (_tmp34_);
#line 93 "../src/math-converter.vala"
	_tmp36_ = _tmp35_;
#line 93 "../src/math-converter.vala"
	_tmp37_ = g_signal_connect_object (_tmp36_, "changed", (GCallback) _math_converter_to_entry_changed_cb_gtk_text_buffer_changed, self, 0);
#line 93 "../src/math-converter.vala"
	self->priv->to_entry_changed = _tmp37_;
#line 95 "../src/math-converter.vala"
	if (gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL) {
#line 571 "math-converter.c"
		GtkTextView* _tmp38_;
		GtkTextView* _tmp39_;
#line 97 "../src/math-converter.vala"
		_tmp38_ = self->priv->from_entry;
#line 97 "../src/math-converter.vala"
		gtk_text_view_set_justification (_tmp38_, GTK_JUSTIFY_RIGHT);
#line 98 "../src/math-converter.vala"
		_tmp39_ = self->priv->to_entry;
#line 98 "../src/math-converter.vala"
		gtk_text_view_set_justification (_tmp39_, GTK_JUSTIFY_RIGHT);
#line 582 "math-converter.c"
	}
#line 101 "../src/math-converter.vala"
	_tmp40_ = self->priv->_equation;
#line 101 "../src/math-converter.vala"
	_tmp41_ = math_equation_get_source_units (_tmp40_);
#line 101 "../src/math-converter.vala"
	_tmp42_ = _tmp41_;
#line 101 "../src/math-converter.vala"
	_tmp43_ = _tmp42_;
#line 101 "../src/math-converter.vala"
	_tmp44_ = self->priv->_equation;
#line 101 "../src/math-converter.vala"
	_tmp45_ = math_equation_get_target_units (_tmp44_);
#line 101 "../src/math-converter.vala"
	_tmp46_ = _tmp45_;
#line 101 "../src/math-converter.vala"
	_tmp47_ = _tmp46_;
#line 101 "../src/math-converter.vala"
	math_converter_set_conversion (self, _tmp43_, _tmp47_);
#line 101 "../src/math-converter.vala"
	_g_free0 (_tmp47_);
#line 101 "../src/math-converter.vala"
	_g_free0 (_tmp43_);
#line 606 "math-converter.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 112 "../src/math-converter.vala"
	return self ? g_object_ref (self) : NULL;
#line 614 "math-converter.c"
}

static gint
____lambda14_ (MathConverter* self,
               GObject* c1,
               GObject* c2)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp6_;
	gint result;
#line 114 "../src/math-converter.vala"
	g_return_val_if_fail (c1 != NULL, 0);
#line 114 "../src/math-converter.vala"
	g_return_val_if_fail (c2 != NULL, 0);
#line 114 "../src/math-converter.vala"
	_tmp0_ = unit_category_get_display_name (G_TYPE_CHECK_INSTANCE_TYPE (c1, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) c1) : NULL);
#line 114 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 114 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 114 "../src/math-converter.vala"
	_tmp3_ = unit_category_get_display_name (G_TYPE_CHECK_INSTANCE_TYPE (c2, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) c2) : NULL);
#line 114 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 114 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 114 "../src/math-converter.vala"
	_tmp6_ = g_utf8_collate (_tmp2_, _tmp5_);
#line 114 "../src/math-converter.vala"
	_g_free0 (_tmp5_);
#line 114 "../src/math-converter.vala"
	_g_free0 (_tmp2_);
#line 114 "../src/math-converter.vala"
	result = _tmp6_;
#line 114 "../src/math-converter.vala"
	return result;
#line 656 "math-converter.c"
}

static gint
_____lambda14__gcompare_data_func (gconstpointer a,
                                   gconstpointer b,
                                   gpointer self)
{
	gint result;
	result = ____lambda14_ ((MathConverter*) self, (GObject*) a, (GObject*) b);
#line 114 "../src/math-converter.vala"
	return result;
#line 668 "math-converter.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 104 "../src/math-converter.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 676 "math-converter.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 104 "../src/math-converter.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 684 "math-converter.c"
}

static void
math_converter_build_category_model (MathConverter* self)
{
	GListStore* category_model = NULL;
	GListStore* _tmp0_;
	GtkPropertyExpression* expression = NULL;
	GtkPropertyExpression* _tmp1_;
	GList* categories = NULL;
	UnitManager* _tmp2_;
	UnitManager* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
	GtkDropDown* _tmp10_;
	GtkPropertyExpression* _tmp11_;
	GtkDropDown* _tmp12_;
	GListStore* _tmp13_;
#line 104 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/math-converter.vala"
	_tmp0_ = g_list_store_new (TYPE_UNIT_CATEGORY);
#line 106 "../src/math-converter.vala"
	category_model = _tmp0_;
#line 107 "../src/math-converter.vala"
	_tmp1_ = (GtkPropertyExpression*) gtk_property_expression_new (TYPE_UNIT_CATEGORY, NULL, "display_name");
#line 107 "../src/math-converter.vala"
	expression = _tmp1_;
#line 111 "../src/math-converter.vala"
	_tmp2_ = unit_manager_get_default ();
#line 111 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 111 "../src/math-converter.vala"
	_tmp4_ = unit_manager_get_categories (_tmp3_);
#line 111 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 111 "../src/math-converter.vala"
	_g_object_unref0 (_tmp3_);
#line 111 "../src/math-converter.vala"
	categories = _tmp5_;
#line 112 "../src/math-converter.vala"
	_tmp6_ = categories;
#line 728 "math-converter.c"
	{
		GList* category_collection = NULL;
		GList* category_it = NULL;
#line 112 "../src/math-converter.vala"
		category_collection = _tmp6_;
#line 112 "../src/math-converter.vala"
		for (category_it = category_collection; category_it != NULL; category_it = category_it->next) {
#line 736 "math-converter.c"
			UnitCategory* _tmp7_;
			UnitCategory* category = NULL;
#line 112 "../src/math-converter.vala"
			_tmp7_ = _g_object_ref0 ((UnitCategory*) category_it->data);
#line 112 "../src/math-converter.vala"
			category = _tmp7_;
#line 743 "math-converter.c"
			{
				GListStore* _tmp8_;
				UnitCategory* _tmp9_;
#line 114 "../src/math-converter.vala"
				_tmp8_ = category_model;
#line 114 "../src/math-converter.vala"
				_tmp9_ = category;
#line 114 "../src/math-converter.vala"
				g_list_store_insert_sorted (_tmp8_, (GObject*) _tmp9_, _____lambda14__gcompare_data_func, self);
#line 112 "../src/math-converter.vala"
				_g_object_unref0 (category);
#line 755 "math-converter.c"
			}
		}
	}
#line 116 "../src/math-converter.vala"
	_tmp10_ = self->priv->category_combo;
#line 116 "../src/math-converter.vala"
	_tmp11_ = expression;
#line 116 "../src/math-converter.vala"
	gtk_drop_down_set_expression (_tmp10_, (GtkExpression*) _tmp11_);
#line 117 "../src/math-converter.vala"
	_tmp12_ = self->priv->category_combo;
#line 117 "../src/math-converter.vala"
	_tmp13_ = category_model;
#line 117 "../src/math-converter.vala"
	gtk_drop_down_set_model (_tmp12_, (GListModel*) _tmp13_);
#line 104 "../src/math-converter.vala"
	(categories == NULL) ? NULL : (categories = (_g_list_free__g_object_unref0_ (categories), NULL));
#line 104 "../src/math-converter.vala"
	_gtk_expression_unref0 (expression);
#line 104 "../src/math-converter.vala"
	_g_object_unref0 (category_model);
#line 777 "math-converter.c"
}

void
math_converter_set_category (MathConverter* self,
                             const gchar* category)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 120 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 122 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp0_, category) == 0) {
#line 123 "../src/math-converter.vala"
		return;
#line 795 "math-converter.c"
	}
#line 124 "../src/math-converter.vala"
	_tmp1_ = g_strdup (category);
#line 124 "../src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 124 "../src/math-converter.vala"
	self->priv->category = _tmp1_;
#line 125 "../src/math-converter.vala"
	_tmp2_ = self->priv->category;
#line 125 "../src/math-converter.vala"
	if (_tmp2_ != NULL) {
#line 807 "math-converter.c"
		UnitCategory* unit_category = NULL;
		UnitManager* _tmp3_;
		UnitManager* _tmp4_;
		const gchar* _tmp5_;
		UnitCategory* _tmp6_;
		UnitCategory* _tmp7_;
		guint position = 0U;
		GListStore* model = NULL;
		GtkDropDown* _tmp8_;
		GListModel* _tmp9_;
		GListStore* _tmp10_;
		GListStore* _tmp11_;
		UnitCategory* _tmp12_;
		guint _tmp13_ = 0U;
		GtkDropDown* _tmp14_;
#line 127 "../src/math-converter.vala"
		_tmp3_ = unit_manager_get_default ();
#line 127 "../src/math-converter.vala"
		_tmp4_ = _tmp3_;
#line 127 "../src/math-converter.vala"
		_tmp5_ = self->priv->category;
#line 127 "../src/math-converter.vala"
		_tmp6_ = unit_manager_get_category (_tmp4_, _tmp5_);
#line 127 "../src/math-converter.vala"
		_tmp7_ = _tmp6_;
#line 127 "../src/math-converter.vala"
		_g_object_unref0 (_tmp4_);
#line 127 "../src/math-converter.vala"
		unit_category = _tmp7_;
#line 128 "../src/math-converter.vala"
		position = (guint) 0;
#line 129 "../src/math-converter.vala"
		_tmp8_ = self->priv->category_combo;
#line 129 "../src/math-converter.vala"
		_tmp9_ = gtk_drop_down_get_model (_tmp8_);
#line 129 "../src/math-converter.vala"
		_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, g_list_store_get_type ()) ? ((GListStore*) _tmp9_) : NULL);
#line 129 "../src/math-converter.vala"
		model = _tmp10_;
#line 130 "../src/math-converter.vala"
		_tmp11_ = model;
#line 130 "../src/math-converter.vala"
		_tmp12_ = unit_category;
#line 130 "../src/math-converter.vala"
		g_list_store_find (_tmp11_, (GObject*) _tmp12_, &_tmp13_);
#line 130 "../src/math-converter.vala"
		position = _tmp13_;
#line 131 "../src/math-converter.vala"
		_tmp14_ = self->priv->category_combo;
#line 131 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp14_, position);
#line 125 "../src/math-converter.vala"
		_g_object_unref0 (model);
#line 125 "../src/math-converter.vala"
		_g_object_unref0 (unit_category);
#line 863 "math-converter.c"
	} else {
		GtkDropDown* _tmp15_;
#line 134 "../src/math-converter.vala"
		_tmp15_ = self->priv->category_combo;
#line 134 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp15_, (guint) 0);
#line 870 "math-converter.c"
	}
}

gchar*
math_converter_get_category (MathConverter* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 137 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 139 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 139 "../src/math-converter.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 139 "../src/math-converter.vala"
	result = _tmp1_;
#line 139 "../src/math-converter.vala"
	return result;
#line 890 "math-converter.c"
}

void
math_converter_set_conversion (MathConverter* self,
                               const gchar* unit_a,
                               const gchar* unit_b)
{
	Unit* ua = NULL;
	UnitManager* _tmp0_;
	UnitManager* _tmp1_;
	Unit* _tmp2_;
	Unit* _tmp3_;
	Unit* ub = NULL;
	UnitManager* _tmp4_;
	UnitManager* _tmp5_;
	Unit* _tmp6_;
	Unit* _tmp7_;
	UnitCategory* uc = NULL;
	UnitManager* _tmp8_;
	UnitManager* _tmp9_;
	UnitCategory* _tmp10_;
	UnitCategory* _tmp11_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	Unit* _tmp14_;
	UnitCategory* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GtkDropDown* _tmp22_;
	GtkDropDown* _tmp23_;
	Unit* _tmp24_;
	GtkDropDown* _tmp25_;
	GtkDropDown* _tmp26_;
	Unit* _tmp27_;
#line 142 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/math-converter.vala"
	g_return_if_fail (unit_a != NULL);
#line 142 "../src/math-converter.vala"
	g_return_if_fail (unit_b != NULL);
#line 144 "../src/math-converter.vala"
	_tmp0_ = unit_manager_get_default ();
#line 144 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 144 "../src/math-converter.vala"
	_tmp2_ = unit_manager_get_unit_by_name (_tmp1_, unit_a);
#line 144 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 144 "../src/math-converter.vala"
	_g_object_unref0 (_tmp1_);
#line 144 "../src/math-converter.vala"
	ua = _tmp3_;
#line 145 "../src/math-converter.vala"
	_tmp4_ = unit_manager_get_default ();
#line 145 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 145 "../src/math-converter.vala"
	_tmp6_ = unit_manager_get_unit_by_name (_tmp5_, unit_b);
#line 145 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 145 "../src/math-converter.vala"
	_g_object_unref0 (_tmp5_);
#line 145 "../src/math-converter.vala"
	ub = _tmp7_;
#line 146 "../src/math-converter.vala"
	_tmp8_ = unit_manager_get_default ();
#line 146 "../src/math-converter.vala"
	_tmp9_ = _tmp8_;
#line 146 "../src/math-converter.vala"
	_tmp10_ = unit_manager_get_category_of_unit (_tmp9_, unit_a);
#line 146 "../src/math-converter.vala"
	_tmp11_ = _tmp10_;
#line 146 "../src/math-converter.vala"
	_g_object_unref0 (_tmp9_);
#line 146 "../src/math-converter.vala"
	uc = _tmp11_;
#line 147 "../src/math-converter.vala"
	_tmp14_ = ua;
#line 147 "../src/math-converter.vala"
	if (_tmp14_ == NULL) {
#line 147 "../src/math-converter.vala"
		_tmp13_ = TRUE;
#line 974 "math-converter.c"
	} else {
		Unit* _tmp15_;
#line 147 "../src/math-converter.vala"
		_tmp15_ = ub;
#line 147 "../src/math-converter.vala"
		_tmp13_ = _tmp15_ == NULL;
#line 981 "math-converter.c"
	}
#line 147 "../src/math-converter.vala"
	if (_tmp13_) {
#line 147 "../src/math-converter.vala"
		_tmp12_ = TRUE;
#line 987 "math-converter.c"
	} else {
		UnitCategory* _tmp16_;
#line 147 "../src/math-converter.vala"
		_tmp16_ = uc;
#line 147 "../src/math-converter.vala"
		_tmp12_ = _tmp16_ == NULL;
#line 994 "math-converter.c"
	}
#line 147 "../src/math-converter.vala"
	if (_tmp12_) {
#line 998 "math-converter.c"
		GtkDropDown* _tmp17_;
#line 149 "../src/math-converter.vala"
		_tmp17_ = self->priv->from_combo;
#line 149 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp17_, (guint) 0);
#line 150 "../src/math-converter.vala"
		_g_object_unref0 (uc);
#line 150 "../src/math-converter.vala"
		_g_object_unref0 (ub);
#line 150 "../src/math-converter.vala"
		_g_object_unref0 (ua);
#line 150 "../src/math-converter.vala"
		return;
#line 1012 "math-converter.c"
	}
#line 153 "../src/math-converter.vala"
	_tmp18_ = uc;
#line 153 "../src/math-converter.vala"
	_tmp19_ = unit_category_get_name (_tmp18_);
#line 153 "../src/math-converter.vala"
	_tmp20_ = _tmp19_;
#line 153 "../src/math-converter.vala"
	_tmp21_ = _tmp20_;
#line 153 "../src/math-converter.vala"
	math_converter_set_category (self, _tmp21_);
#line 153 "../src/math-converter.vala"
	_g_free0 (_tmp21_);
#line 154 "../src/math-converter.vala"
	_tmp22_ = self->priv->from_combo;
#line 154 "../src/math-converter.vala"
	g_signal_handler_block (_tmp22_, self->priv->from_combobox_changed);
#line 155 "../src/math-converter.vala"
	_tmp23_ = self->priv->from_combo;
#line 155 "../src/math-converter.vala"
	_tmp24_ = ua;
#line 155 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp23_, _tmp24_);
#line 156 "../src/math-converter.vala"
	_tmp25_ = self->priv->from_combo;
#line 156 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp25_, self->priv->from_combobox_changed);
#line 157 "../src/math-converter.vala"
	_tmp26_ = self->priv->to_combo;
#line 157 "../src/math-converter.vala"
	_tmp27_ = ub;
#line 157 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp26_, _tmp27_);
#line 158 "../src/math-converter.vala"
	math_converter_to_combobox_changed_cb (self);
#line 142 "../src/math-converter.vala"
	_g_object_unref0 (uc);
#line 142 "../src/math-converter.vala"
	_g_object_unref0 (ub);
#line 142 "../src/math-converter.vala"
	_g_object_unref0 (ua);
#line 1054 "math-converter.c"
}

void
math_converter_get_conversion (MathConverter* self,
                               Unit** from_unit,
                               Unit** to_unit)
{
	Unit* _vala_from_unit = NULL;
	Unit* _vala_to_unit = NULL;
	GtkDropDown* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	Unit* _tmp3_;
	GtkDropDown* _tmp4_;
	GObject* _tmp5_;
	GObject* _tmp6_;
	Unit* _tmp7_;
#line 161 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_combo;
#line 164 "../src/math-converter.vala"
	_tmp1_ = gtk_drop_down_get_selected_item (_tmp0_);
#line 164 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 164 "../src/math-converter.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, TYPE_UNIT) ? ((Unit*) _tmp2_) : NULL);
#line 164 "../src/math-converter.vala"
	_g_object_unref0 (_vala_from_unit);
#line 164 "../src/math-converter.vala"
	_vala_from_unit = _tmp3_;
#line 165 "../src/math-converter.vala"
	_tmp4_ = self->priv->to_combo;
#line 165 "../src/math-converter.vala"
	_tmp5_ = gtk_drop_down_get_selected_item (_tmp4_);
#line 165 "../src/math-converter.vala"
	_tmp6_ = _tmp5_;
#line 165 "../src/math-converter.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, TYPE_UNIT) ? ((Unit*) _tmp6_) : NULL);
#line 165 "../src/math-converter.vala"
	_g_object_unref0 (_vala_to_unit);
#line 165 "../src/math-converter.vala"
	_vala_to_unit = _tmp7_;
#line 161 "../src/math-converter.vala"
	if (from_unit) {
#line 161 "../src/math-converter.vala"
		*from_unit = _vala_from_unit;
#line 1102 "math-converter.c"
	} else {
#line 161 "../src/math-converter.vala"
		_g_object_unref0 (_vala_from_unit);
#line 1106 "math-converter.c"
	}
#line 161 "../src/math-converter.vala"
	if (to_unit) {
#line 161 "../src/math-converter.vala"
		*to_unit = _vala_to_unit;
#line 1112 "math-converter.c"
	} else {
#line 161 "../src/math-converter.vala"
		_g_object_unref0 (_vala_to_unit);
#line 1116 "math-converter.c"
	}
}

void
math_converter_insert_text (MathConverter* self,
                            const gchar* text)
{
	gboolean _tmp0_;
	GtkTextView* _tmp1_ = NULL;
	GtkTextView* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp7_;
	GtkTextView* _tmp8_;
	GtkTextView* _tmp9_;
	GtkTextView* _tmp11_;
	GtkTextBuffer* _tmp12_;
	GtkTextBuffer* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gboolean _tmp17_;
	GtkTextView* _tmp29_;
	GtkTextBuffer* _tmp30_;
	GtkTextBuffer* _tmp31_;
	GtkTextView* _tmp32_;
	GtkTextBuffer* _tmp33_;
	GtkTextBuffer* _tmp34_;
	gint _tmp35_;
	gint _tmp36_;
#line 168 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/math-converter.vala"
	g_return_if_fail (text != NULL);
#line 170 "../src/math-converter.vala"
	_tmp0_ = self->priv->_box_visible;
#line 170 "../src/math-converter.vala"
	if (!_tmp0_) {
#line 171 "../src/math-converter.vala"
		return;
#line 1158 "math-converter.c"
	}
#line 173 "../src/math-converter.vala"
	_tmp2_ = self->priv->to_entry;
#line 173 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp2_, "has-focus", &_tmp3_, NULL);
#line 173 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 173 "../src/math-converter.vala"
	if (_tmp4_) {
#line 1168 "math-converter.c"
		GtkTextView* _tmp5_;
#line 173 "../src/math-converter.vala"
		_tmp5_ = self->priv->to_entry;
#line 173 "../src/math-converter.vala"
		_tmp1_ = _tmp5_;
#line 1174 "math-converter.c"
	} else {
		GtkTextView* _tmp6_;
#line 173 "../src/math-converter.vala"
		_tmp6_ = self->priv->from_entry;
#line 173 "../src/math-converter.vala"
		_tmp1_ = _tmp6_;
#line 1181 "math-converter.c"
	}
#line 173 "../src/math-converter.vala"
	_tmp7_ = _g_object_ref0 (_tmp1_);
#line 173 "../src/math-converter.vala"
	entry = _tmp7_;
#line 174 "../src/math-converter.vala"
	_tmp8_ = entry;
#line 174 "../src/math-converter.vala"
	_tmp9_ = self->priv->from_entry;
#line 174 "../src/math-converter.vala"
	if (_tmp8_ == _tmp9_) {
#line 1193 "math-converter.c"
		GtkTextView* _tmp10_;
#line 175 "../src/math-converter.vala"
		_tmp10_ = self->priv->from_entry;
#line 175 "../src/math-converter.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 1199 "math-converter.c"
	}
#line 176 "../src/math-converter.vala"
	_tmp11_ = entry;
#line 176 "../src/math-converter.vala"
	_tmp12_ = gtk_text_view_get_buffer (_tmp11_);
#line 176 "../src/math-converter.vala"
	_tmp13_ = _tmp12_;
#line 176 "../src/math-converter.vala"
	g_object_get (_tmp13_, "text", &_tmp14_, NULL);
#line 176 "../src/math-converter.vala"
	_tmp15_ = _tmp14_;
#line 176 "../src/math-converter.vala"
	_tmp16_ = _tmp15_;
#line 176 "../src/math-converter.vala"
	_tmp17_ = g_strcmp0 (_tmp16_, "0") == 0;
#line 176 "../src/math-converter.vala"
	_g_free0 (_tmp16_);
#line 176 "../src/math-converter.vala"
	if (_tmp17_) {
#line 1219 "math-converter.c"
		GtkTextIter iter = {0};
		GtkTextView* _tmp18_;
		GtkTextBuffer* _tmp19_;
		GtkTextBuffer* _tmp20_;
		GtkTextView* _tmp21_;
		GtkTextBuffer* _tmp22_;
		GtkTextBuffer* _tmp23_;
		GtkTextMark* _tmp24_;
		GtkTextIter _tmp25_ = {0};
#line 179 "../src/math-converter.vala"
		_tmp18_ = entry;
#line 179 "../src/math-converter.vala"
		_tmp19_ = gtk_text_view_get_buffer (_tmp18_);
#line 179 "../src/math-converter.vala"
		_tmp20_ = _tmp19_;
#line 179 "../src/math-converter.vala"
		_tmp21_ = entry;
#line 179 "../src/math-converter.vala"
		_tmp22_ = gtk_text_view_get_buffer (_tmp21_);
#line 179 "../src/math-converter.vala"
		_tmp23_ = _tmp22_;
#line 179 "../src/math-converter.vala"
		_tmp24_ = gtk_text_buffer_get_insert (_tmp23_);
#line 179 "../src/math-converter.vala"
		gtk_text_buffer_get_iter_at_mark (_tmp20_, &_tmp25_, _tmp24_);
#line 179 "../src/math-converter.vala"
		iter = _tmp25_;
#line 180 "../src/math-converter.vala"
		if (gtk_text_iter_is_end (&iter)) {
#line 1249 "math-converter.c"
			GtkTextView* _tmp26_;
			GtkTextBuffer* _tmp27_;
			GtkTextBuffer* _tmp28_;
#line 181 "../src/math-converter.vala"
			_tmp26_ = entry;
#line 181 "../src/math-converter.vala"
			_tmp27_ = gtk_text_view_get_buffer (_tmp26_);
#line 181 "../src/math-converter.vala"
			_tmp28_ = _tmp27_;
#line 181 "../src/math-converter.vala"
			g_object_set (_tmp28_, "text", "", NULL);
#line 1261 "math-converter.c"
		}
	}
#line 183 "../src/math-converter.vala"
	_tmp29_ = entry;
#line 183 "../src/math-converter.vala"
	_tmp30_ = gtk_text_view_get_buffer (_tmp29_);
#line 183 "../src/math-converter.vala"
	_tmp31_ = _tmp30_;
#line 183 "../src/math-converter.vala"
	gtk_text_buffer_delete_selection (_tmp31_, TRUE, TRUE);
#line 184 "../src/math-converter.vala"
	_tmp32_ = entry;
#line 184 "../src/math-converter.vala"
	_tmp33_ = gtk_text_view_get_buffer (_tmp32_);
#line 184 "../src/math-converter.vala"
	_tmp34_ = _tmp33_;
#line 184 "../src/math-converter.vala"
	_tmp35_ = strlen (text);
#line 184 "../src/math-converter.vala"
	_tmp36_ = _tmp35_;
#line 184 "../src/math-converter.vala"
	gtk_text_buffer_insert_at_cursor (_tmp34_, text, _tmp36_);
#line 168 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 1286 "math-converter.c"
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1122 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1122 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1123 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1124 "glib-2.0.vapi"
	result = str;
#line 1124 "glib-2.0.vapi"
	return result;
#line 1305 "math-converter.c"
}

void
math_converter_insert_numeric_point (MathConverter* self)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	GtkTextView* _tmp7_;
	GtkTextView* _tmp8_;
	gchar* text = NULL;
	Serializer* _tmp10_;
	gchar* _tmp11_;
	GtkTextView* _tmp12_;
	GtkTextBuffer* _tmp13_;
	GtkTextBuffer* _tmp14_;
	GtkTextView* _tmp15_;
	GtkTextBuffer* _tmp16_;
	GtkTextBuffer* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
#line 187 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/math-converter.vala"
	_tmp1_ = self->priv->to_entry;
#line 189 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 189 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 189 "../src/math-converter.vala"
	if (_tmp3_) {
#line 1340 "math-converter.c"
		GtkTextView* _tmp4_;
#line 189 "../src/math-converter.vala"
		_tmp4_ = self->priv->to_entry;
#line 189 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 1346 "math-converter.c"
	} else {
		GtkTextView* _tmp5_;
#line 189 "../src/math-converter.vala"
		_tmp5_ = self->priv->from_entry;
#line 189 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 1353 "math-converter.c"
	}
#line 189 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 189 "../src/math-converter.vala"
	entry = _tmp6_;
#line 190 "../src/math-converter.vala"
	_tmp7_ = entry;
#line 190 "../src/math-converter.vala"
	_tmp8_ = self->priv->from_entry;
#line 190 "../src/math-converter.vala"
	if (_tmp7_ == _tmp8_) {
#line 1365 "math-converter.c"
		GtkTextView* _tmp9_;
#line 191 "../src/math-converter.vala"
		_tmp9_ = self->priv->from_entry;
#line 191 "../src/math-converter.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
#line 1371 "math-converter.c"
	}
#line 192 "../src/math-converter.vala"
	_tmp10_ = self->priv->fixed_serializer;
#line 192 "../src/math-converter.vala"
	_tmp11_ = g_unichar_to_string (serializer_get_radix (_tmp10_));
#line 192 "../src/math-converter.vala"
	text = _tmp11_;
#line 193 "../src/math-converter.vala"
	_tmp12_ = entry;
#line 193 "../src/math-converter.vala"
	_tmp13_ = gtk_text_view_get_buffer (_tmp12_);
#line 193 "../src/math-converter.vala"
	_tmp14_ = _tmp13_;
#line 193 "../src/math-converter.vala"
	gtk_text_buffer_delete_selection (_tmp14_, TRUE, TRUE);
#line 194 "../src/math-converter.vala"
	_tmp15_ = entry;
#line 194 "../src/math-converter.vala"
	_tmp16_ = gtk_text_view_get_buffer (_tmp15_);
#line 194 "../src/math-converter.vala"
	_tmp17_ = _tmp16_;
#line 194 "../src/math-converter.vala"
	_tmp18_ = strlen (text);
#line 194 "../src/math-converter.vala"
	_tmp19_ = _tmp18_;
#line 194 "../src/math-converter.vala"
	gtk_text_buffer_insert_at_cursor (_tmp17_, text, _tmp19_);
#line 187 "../src/math-converter.vala"
	_g_free0 (text);
#line 187 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 1403 "math-converter.c"
}

void
math_converter_clear (MathConverter* self)
{
	gboolean _tmp0_;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 197 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/math-converter.vala"
	_tmp0_ = self->priv->_box_visible;
#line 199 "../src/math-converter.vala"
	if (!_tmp0_) {
#line 200 "../src/math-converter.vala"
		return;
#line 1421 "math-converter.c"
	}
#line 202 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 202 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 202 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 202 "../src/math-converter.vala"
	if (_tmp3_) {
#line 1431 "math-converter.c"
		GtkTextView* _tmp4_;
		GtkTextBuffer* _tmp5_;
		GtkTextBuffer* _tmp6_;
#line 203 "../src/math-converter.vala"
		_tmp4_ = self->priv->from_entry;
#line 203 "../src/math-converter.vala"
		_tmp5_ = gtk_text_view_get_buffer (_tmp4_);
#line 203 "../src/math-converter.vala"
		_tmp6_ = _tmp5_;
#line 203 "../src/math-converter.vala"
		g_object_set (_tmp6_, "text", "0", NULL);
#line 1443 "math-converter.c"
	} else {
		GtkTextView* _tmp7_;
		GtkTextBuffer* _tmp8_;
		GtkTextBuffer* _tmp9_;
		MathEquation* _tmp10_;
		Serializer* _tmp11_;
		Serializer* _tmp12_;
		Number* _tmp13_;
		Number* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 205 "../src/math-converter.vala"
		_tmp7_ = self->priv->from_entry;
#line 205 "../src/math-converter.vala"
		_tmp8_ = gtk_text_view_get_buffer (_tmp7_);
#line 205 "../src/math-converter.vala"
		_tmp9_ = _tmp8_;
#line 205 "../src/math-converter.vala"
		_tmp10_ = self->priv->_equation;
#line 205 "../src/math-converter.vala"
		_tmp11_ = math_equation_get_serializer (_tmp10_);
#line 205 "../src/math-converter.vala"
		_tmp12_ = _tmp11_;
#line 205 "../src/math-converter.vala"
		_tmp13_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 205 "../src/math-converter.vala"
		_tmp14_ = _tmp13_;
#line 205 "../src/math-converter.vala"
		_tmp15_ = serializer_to_string (_tmp12_, _tmp14_);
#line 205 "../src/math-converter.vala"
		_tmp16_ = _tmp15_;
#line 205 "../src/math-converter.vala"
		g_object_set (_tmp9_, "text", _tmp16_, NULL);
#line 205 "../src/math-converter.vala"
		_g_free0 (_tmp16_);
#line 205 "../src/math-converter.vala"
		_g_object_unref0 (_tmp14_);
#line 1481 "math-converter.c"
	}
}

void
math_converter_swap_units (MathConverter* self)
{
	gboolean _tmp0_;
	Unit* from_unit = NULL;
	GtkDropDown* _tmp1_;
	GObject* _tmp2_;
	GObject* _tmp3_;
	Unit* _tmp4_;
	Unit* to_unit = NULL;
	GtkDropDown* _tmp5_;
	GObject* _tmp6_;
	GObject* _tmp7_;
	Unit* _tmp8_;
	GtkDropDown* _tmp9_;
	GtkDropDown* _tmp10_;
	Unit* _tmp11_;
	GtkDropDown* _tmp12_;
	GtkDropDown* _tmp13_;
	Unit* _tmp14_;
#line 208 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 210 "../src/math-converter.vala"
	_tmp0_ = self->priv->_box_visible;
#line 210 "../src/math-converter.vala"
	if (!_tmp0_) {
#line 211 "../src/math-converter.vala"
		return;
#line 1513 "math-converter.c"
	}
#line 213 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_combo;
#line 213 "../src/math-converter.vala"
	_tmp2_ = gtk_drop_down_get_selected_item (_tmp1_);
#line 213 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 213 "../src/math-converter.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, TYPE_UNIT) ? ((Unit*) _tmp3_) : NULL);
#line 213 "../src/math-converter.vala"
	from_unit = _tmp4_;
#line 214 "../src/math-converter.vala"
	_tmp5_ = self->priv->to_combo;
#line 214 "../src/math-converter.vala"
	_tmp6_ = gtk_drop_down_get_selected_item (_tmp5_);
#line 214 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 214 "../src/math-converter.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, TYPE_UNIT) ? ((Unit*) _tmp7_) : NULL);
#line 214 "../src/math-converter.vala"
	to_unit = _tmp8_;
#line 216 "../src/math-converter.vala"
	_tmp9_ = self->priv->from_combo;
#line 216 "../src/math-converter.vala"
	g_signal_handler_block (_tmp9_, self->priv->from_combobox_changed);
#line 217 "../src/math-converter.vala"
	_tmp10_ = self->priv->from_combo;
#line 217 "../src/math-converter.vala"
	_tmp11_ = to_unit;
#line 217 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp10_, _tmp11_);
#line 218 "../src/math-converter.vala"
	_tmp12_ = self->priv->from_combo;
#line 218 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp12_, self->priv->from_combobox_changed);
#line 219 "../src/math-converter.vala"
	_tmp13_ = self->priv->to_combo;
#line 219 "../src/math-converter.vala"
	_tmp14_ = from_unit;
#line 219 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp13_, _tmp14_);
#line 208 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 208 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 1559 "math-converter.c"
}

void
math_converter_backspace (MathConverter* self)
{
	gboolean _tmp0_;
	GtkTextView* _tmp1_ = NULL;
	GtkTextView* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp7_;
	GtkTextView* _tmp8_;
	GtkTextView* _tmp9_;
	GtkTextView* _tmp11_;
	GtkTextBuffer* _tmp12_;
	GtkTextBuffer* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
#line 222 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 224 "../src/math-converter.vala"
	_tmp0_ = self->priv->_box_visible;
#line 224 "../src/math-converter.vala"
	if (!_tmp0_) {
#line 225 "../src/math-converter.vala"
		return;
#line 1587 "math-converter.c"
	}
#line 227 "../src/math-converter.vala"
	_tmp2_ = self->priv->to_entry;
#line 227 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp2_, "has-focus", &_tmp3_, NULL);
#line 227 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 227 "../src/math-converter.vala"
	if (_tmp4_) {
#line 1597 "math-converter.c"
		GtkTextView* _tmp5_;
#line 227 "../src/math-converter.vala"
		_tmp5_ = self->priv->to_entry;
#line 227 "../src/math-converter.vala"
		_tmp1_ = _tmp5_;
#line 1603 "math-converter.c"
	} else {
		GtkTextView* _tmp6_;
#line 227 "../src/math-converter.vala"
		_tmp6_ = self->priv->from_entry;
#line 227 "../src/math-converter.vala"
		_tmp1_ = _tmp6_;
#line 1610 "math-converter.c"
	}
#line 227 "../src/math-converter.vala"
	_tmp7_ = _g_object_ref0 (_tmp1_);
#line 227 "../src/math-converter.vala"
	entry = _tmp7_;
#line 228 "../src/math-converter.vala"
	_tmp8_ = entry;
#line 228 "../src/math-converter.vala"
	_tmp9_ = self->priv->from_entry;
#line 228 "../src/math-converter.vala"
	if (_tmp8_ == _tmp9_) {
#line 1622 "math-converter.c"
		GtkTextView* _tmp10_;
#line 229 "../src/math-converter.vala"
		_tmp10_ = self->priv->from_entry;
#line 229 "../src/math-converter.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 1628 "math-converter.c"
	}
#line 230 "../src/math-converter.vala"
	_tmp11_ = entry;
#line 230 "../src/math-converter.vala"
	_tmp12_ = gtk_text_view_get_buffer (_tmp11_);
#line 230 "../src/math-converter.vala"
	_tmp13_ = _tmp12_;
#line 230 "../src/math-converter.vala"
	_tmp14_ = gtk_text_buffer_get_has_selection (_tmp13_);
#line 230 "../src/math-converter.vala"
	_tmp15_ = _tmp14_;
#line 230 "../src/math-converter.vala"
	if (_tmp15_) {
#line 1642 "math-converter.c"
		GtkTextView* _tmp16_;
		GtkTextBuffer* _tmp17_;
		GtkTextBuffer* _tmp18_;
#line 232 "../src/math-converter.vala"
		_tmp16_ = entry;
#line 232 "../src/math-converter.vala"
		_tmp17_ = gtk_text_view_get_buffer (_tmp16_);
#line 232 "../src/math-converter.vala"
		_tmp18_ = _tmp17_;
#line 232 "../src/math-converter.vala"
		gtk_text_buffer_delete_selection (_tmp18_, TRUE, TRUE);
#line 1654 "math-converter.c"
	} else {
		GtkTextIter iter = {0};
		GtkTextView* _tmp19_;
		GtkTextBuffer* _tmp20_;
		GtkTextBuffer* _tmp21_;
		GtkTextView* _tmp22_;
		GtkTextBuffer* _tmp23_;
		GtkTextBuffer* _tmp24_;
		GtkTextMark* _tmp25_;
		GtkTextIter _tmp26_ = {0};
		GtkTextView* _tmp27_;
		GtkTextBuffer* _tmp28_;
		GtkTextBuffer* _tmp29_;
#line 237 "../src/math-converter.vala"
		_tmp19_ = entry;
#line 237 "../src/math-converter.vala"
		_tmp20_ = gtk_text_view_get_buffer (_tmp19_);
#line 237 "../src/math-converter.vala"
		_tmp21_ = _tmp20_;
#line 237 "../src/math-converter.vala"
		_tmp22_ = entry;
#line 237 "../src/math-converter.vala"
		_tmp23_ = gtk_text_view_get_buffer (_tmp22_);
#line 237 "../src/math-converter.vala"
		_tmp24_ = _tmp23_;
#line 237 "../src/math-converter.vala"
		_tmp25_ = gtk_text_buffer_get_insert (_tmp24_);
#line 237 "../src/math-converter.vala"
		gtk_text_buffer_get_iter_at_mark (_tmp21_, &_tmp26_, _tmp25_);
#line 237 "../src/math-converter.vala"
		iter = _tmp26_;
#line 238 "../src/math-converter.vala"
		_tmp27_ = entry;
#line 238 "../src/math-converter.vala"
		_tmp28_ = gtk_text_view_get_buffer (_tmp27_);
#line 238 "../src/math-converter.vala"
		_tmp29_ = _tmp28_;
#line 238 "../src/math-converter.vala"
		gtk_text_buffer_backspace (_tmp29_, &iter, TRUE, TRUE);
#line 1694 "math-converter.c"
	}
#line 222 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 1698 "math-converter.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 242 "../src/math-converter.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 242 "../src/math-converter.vala"
	return _data3_;
#line 1708 "math-converter.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 242 "../src/math-converter.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1718 "math-converter.c"
		MathConverter* self;
#line 242 "../src/math-converter.vala"
		self = _data3_->self;
#line 242 "../src/math-converter.vala"
		_g_object_unref0 (_data3_->clipboard);
#line 242 "../src/math-converter.vala"
		_g_object_unref0 (self);
#line 242 "../src/math-converter.vala"
		g_slice_free (Block3Data, _data3_);
#line 1728 "math-converter.c"
	}
}

static void
__lambda12_ (Block3Data* _data3_,
             GObject* obj,
             GAsyncResult* res)
{
	MathConverter* self;
	GError* _inner_error0_ = NULL;
#line 247 "../src/math-converter.vala"
	self = _data3_->self;
#line 247 "../src/math-converter.vala"
	g_return_if_fail (res != NULL);
#line 1743 "math-converter.c"
	{
		gchar* _tmp0_ = NULL;
		GdkClipboard* _tmp1_;
		gchar* _tmp2_;
#line 249 "../src/math-converter.vala"
		_tmp1_ = _data3_->clipboard;
#line 249 "../src/math-converter.vala"
		_tmp2_ = gdk_clipboard_read_text_finish (_tmp1_, res, &_inner_error0_);
#line 249 "../src/math-converter.vala"
		_tmp0_ = _tmp2_;
#line 249 "../src/math-converter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1756 "math-converter.c"
			goto __catch0_g_error;
		}
#line 249 "../src/math-converter.vala"
		math_converter_on_paste (self, _tmp0_);
#line 248 "../src/math-converter.vala"
		_g_free0 (_tmp0_);
#line 1763 "math-converter.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 248 "../src/math-converter.vala"
		err = _inner_error0_;
#line 248 "../src/math-converter.vala"
		_inner_error0_ = NULL;
#line 251 "../src/math-converter.vala"
		_tmp3_ = err;
#line 251 "../src/math-converter.vala"
		_tmp4_ = _tmp3_->message;
#line 251 "../src/math-converter.vala"
		g_print ("%s", _tmp4_);
#line 248 "../src/math-converter.vala"
		_g_error_free0 (err);
#line 1783 "math-converter.c"
	}
	__finally0:
#line 248 "../src/math-converter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "../src/math-converter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 248 "../src/math-converter.vala"
		g_clear_error (&_inner_error0_);
#line 248 "../src/math-converter.vala"
		return;
#line 1794 "math-converter.c"
	}
}

static void
___lambda12__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 247 "../src/math-converter.vala"
	__lambda12_ (self, source_object, res);
#line 247 "../src/math-converter.vala"
	block3_data_unref (self);
#line 1807 "math-converter.c"
}

void
math_converter_paste (MathConverter* self)
{
	Block3Data* _data3_;
	gboolean _tmp0_ = FALSE;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GdkDisplay* _tmp7_;
	GdkClipboard* _tmp8_;
	GdkClipboard* _tmp9_;
	GdkClipboard* _tmp10_;
#line 242 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/math-converter.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 242 "../src/math-converter.vala"
	_data3_->_ref_count_ = 1;
#line 242 "../src/math-converter.vala"
	_data3_->self = g_object_ref (self);
#line 244 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 244 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 244 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 244 "../src/math-converter.vala"
	if (!_tmp3_) {
#line 1838 "math-converter.c"
		GtkTextView* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 244 "../src/math-converter.vala"
		_tmp4_ = self->priv->to_entry;
#line 244 "../src/math-converter.vala"
		g_object_get ((GtkWidget*) _tmp4_, "has-focus", &_tmp5_, NULL);
#line 244 "../src/math-converter.vala"
		_tmp6_ = _tmp5_;
#line 244 "../src/math-converter.vala"
		_tmp0_ = !_tmp6_;
#line 1850 "math-converter.c"
	} else {
#line 244 "../src/math-converter.vala"
		_tmp0_ = FALSE;
#line 1854 "math-converter.c"
	}
#line 244 "../src/math-converter.vala"
	if (_tmp0_) {
#line 245 "../src/math-converter.vala"
		block3_data_unref (_data3_);
#line 245 "../src/math-converter.vala"
		_data3_ = NULL;
#line 245 "../src/math-converter.vala"
		return;
#line 1864 "math-converter.c"
	}
#line 246 "../src/math-converter.vala"
	_tmp7_ = gdk_display_get_default ();
#line 246 "../src/math-converter.vala"
	_tmp8_ = gdk_display_get_clipboard (_tmp7_);
#line 246 "../src/math-converter.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 246 "../src/math-converter.vala"
	_data3_->clipboard = _tmp9_;
#line 247 "../src/math-converter.vala"
	_tmp10_ = _data3_->clipboard;
#line 247 "../src/math-converter.vala"
	gdk_clipboard_read_text_async (_tmp10_, NULL, ___lambda12__gasync_ready_callback, block3_data_ref (_data3_));
#line 242 "../src/math-converter.vala"
	block3_data_unref (_data3_);
#line 242 "../src/math-converter.vala"
	_data3_ = NULL;
#line 1882 "math-converter.c"
}

static gchar*
string_delimit (const gchar* self,
                const gchar* delimiters,
                gchar new_delimiter)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail (delimiters != NULL, NULL);
#line 1422 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1422 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1423 "glib-2.0.vapi"
	g_strdelimit (_result_, delimiters, new_delimiter);
#line 1424 "glib-2.0.vapi"
	result = _result_;
#line 1424 "glib-2.0.vapi"
	return result;
#line 1907 "math-converter.c"
}

static void
math_converter_on_paste (MathConverter* self,
                         const gchar* text)
{
#line 256 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 258 "../src/math-converter.vala"
	if (text != NULL) {
#line 1918 "math-converter.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 260 "../src/math-converter.vala"
		_tmp0_ = string_delimit (text, "\n", ' ');
#line 260 "../src/math-converter.vala"
		_tmp1_ = _tmp0_;
#line 260 "../src/math-converter.vala"
		math_converter_insert_text (self, _tmp1_);
#line 260 "../src/math-converter.vala"
		_g_free0 (_tmp1_);
#line 1929 "math-converter.c"
	}
}

static void
math_converter_update_visibility (MathConverter* self)
{
	const gchar* _tmp0_;
	CurrencyManager* _tmp1_;
	CurrencyManager* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 263 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 265 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 265 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp0_, "currency") != 0) {
#line 267 "../src/math-converter.vala"
		math_converter_set_box_visible (self, TRUE);
#line 268 "../src/math-converter.vala"
		return;
#line 1951 "math-converter.c"
	}
#line 271 "../src/math-converter.vala"
	_tmp1_ = currency_manager_get_default (TRUE, TRUE);
#line 271 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 271 "../src/math-converter.vala"
	_tmp3_ = currency_manager_get_loaded (_tmp2_);
#line 271 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 271 "../src/math-converter.vala"
	math_converter_set_box_visible (self, _tmp4_);
#line 271 "../src/math-converter.vala"
	_g_object_unref0 (_tmp2_);
#line 1965 "math-converter.c"
}

static void
math_converter_build_units_model (MathConverter* self)
{
	GListStore* unit_model = NULL;
	GListStore* _tmp0_;
	GtkPropertyExpression* expression = NULL;
	GtkPropertyExpression* _tmp1_;
	GtkDropDown* _tmp2_;
	GtkPropertyExpression* _tmp3_;
	GtkDropDown* _tmp4_;
	GtkPropertyExpression* _tmp5_;
	UnitCategory* c = NULL;
	UnitManager* _tmp6_;
	UnitManager* _tmp7_;
	const gchar* _tmp8_;
	UnitCategory* _tmp9_;
	UnitCategory* _tmp10_;
	UnitCategory* _tmp11_;
	GList* _tmp12_;
	guint model_size = 0U;
	GListStore* _tmp16_;
	GtkDropDown* _tmp17_;
	GListStore* _tmp18_;
	GtkDropDown* _tmp19_;
	GtkDropDown* _tmp20_;
	GListStore* _tmp21_;
	GtkDropDown* _tmp22_;
#line 274 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 276 "../src/math-converter.vala"
	_tmp0_ = g_list_store_new (TYPE_UNIT);
#line 276 "../src/math-converter.vala"
	unit_model = _tmp0_;
#line 278 "../src/math-converter.vala"
	_tmp1_ = (GtkPropertyExpression*) gtk_property_expression_new (TYPE_UNIT, NULL, "display_name");
#line 278 "../src/math-converter.vala"
	expression = _tmp1_;
#line 281 "../src/math-converter.vala"
	_tmp2_ = self->priv->from_combo;
#line 281 "../src/math-converter.vala"
	_tmp3_ = expression;
#line 281 "../src/math-converter.vala"
	gtk_drop_down_set_expression (_tmp2_, (GtkExpression*) _tmp3_);
#line 282 "../src/math-converter.vala"
	_tmp4_ = self->priv->to_combo;
#line 282 "../src/math-converter.vala"
	_tmp5_ = expression;
#line 282 "../src/math-converter.vala"
	gtk_drop_down_set_expression (_tmp4_, (GtkExpression*) _tmp5_);
#line 284 "../src/math-converter.vala"
	_tmp6_ = unit_manager_get_default ();
#line 284 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 284 "../src/math-converter.vala"
	_tmp8_ = self->priv->category;
#line 284 "../src/math-converter.vala"
	_tmp9_ = unit_manager_get_category (_tmp7_, _tmp8_);
#line 284 "../src/math-converter.vala"
	_tmp10_ = _tmp9_;
#line 284 "../src/math-converter.vala"
	_g_object_unref0 (_tmp7_);
#line 284 "../src/math-converter.vala"
	c = _tmp10_;
#line 285 "../src/math-converter.vala"
	_tmp11_ = c;
#line 285 "../src/math-converter.vala"
	_tmp12_ = unit_category_get_units (_tmp11_);
#line 2035 "math-converter.c"
	{
		GList* unit_collection = NULL;
		GList* unit_it = NULL;
#line 285 "../src/math-converter.vala"
		unit_collection = _tmp12_;
#line 285 "../src/math-converter.vala"
		for (unit_it = unit_collection; unit_it != NULL; unit_it = unit_it->next) {
#line 2043 "math-converter.c"
			Unit* _tmp13_;
			Unit* unit = NULL;
#line 285 "../src/math-converter.vala"
			_tmp13_ = _g_object_ref0 ((Unit*) unit_it->data);
#line 285 "../src/math-converter.vala"
			unit = _tmp13_;
#line 2050 "math-converter.c"
			{
				GListStore* _tmp14_;
				Unit* _tmp15_;
#line 287 "../src/math-converter.vala"
				_tmp14_ = unit_model;
#line 287 "../src/math-converter.vala"
				_tmp15_ = unit;
#line 287 "../src/math-converter.vala"
				g_list_store_append (_tmp14_, (GObject*) _tmp15_);
#line 285 "../src/math-converter.vala"
				_g_object_unref0 (unit);
#line 2062 "math-converter.c"
			}
		}
	}
#line 290 "../src/math-converter.vala"
	_tmp16_ = unit_model;
#line 290 "../src/math-converter.vala"
	model_size = g_list_model_get_n_items ((GListModel*) _tmp16_);
#line 291 "../src/math-converter.vala"
	_tmp17_ = self->priv->to_combo;
#line 291 "../src/math-converter.vala"
	_tmp18_ = unit_model;
#line 291 "../src/math-converter.vala"
	gtk_drop_down_set_model (_tmp17_, (GListModel*) _tmp18_);
#line 292 "../src/math-converter.vala"
	_tmp19_ = self->priv->to_combo;
#line 292 "../src/math-converter.vala"
	gtk_drop_down_set_enable_search (_tmp19_, model_size > ((guint) 10));
#line 293 "../src/math-converter.vala"
	_tmp20_ = self->priv->from_combo;
#line 293 "../src/math-converter.vala"
	_tmp21_ = unit_model;
#line 293 "../src/math-converter.vala"
	gtk_drop_down_set_model (_tmp20_, (GListModel*) _tmp21_);
#line 294 "../src/math-converter.vala"
	_tmp22_ = self->priv->from_combo;
#line 294 "../src/math-converter.vala"
	gtk_drop_down_set_enable_search (_tmp22_, model_size > ((guint) 10));
#line 274 "../src/math-converter.vala"
	_g_object_unref0 (c);
#line 274 "../src/math-converter.vala"
	_gtk_expression_unref0 (expression);
#line 274 "../src/math-converter.vala"
	_g_object_unref0 (unit_model);
#line 2096 "math-converter.c"
}

static gboolean
math_converter_set_active_unit (MathConverter* self,
                                GtkDropDown* combo,
                                Unit* unit)
{
	guint position = 0U;
	GListStore* model = NULL;
	GListModel* _tmp0_;
	GListStore* _tmp1_;
	GListStore* _tmp2_;
	guint _tmp3_ = 0U;
	gboolean result;
#line 297 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 297 "../src/math-converter.vala"
	g_return_val_if_fail (combo != NULL, FALSE);
#line 297 "../src/math-converter.vala"
	g_return_val_if_fail (unit != NULL, FALSE);
#line 299 "../src/math-converter.vala"
	position = (guint) 0;
#line 300 "../src/math-converter.vala"
	_tmp0_ = gtk_drop_down_get_model (combo);
#line 300 "../src/math-converter.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_list_store_get_type ()) ? ((GListStore*) _tmp0_) : NULL);
#line 300 "../src/math-converter.vala"
	model = _tmp1_;
#line 301 "../src/math-converter.vala"
	_tmp2_ = model;
#line 301 "../src/math-converter.vala"
	g_list_store_find (_tmp2_, (GObject*) unit, &_tmp3_);
#line 301 "../src/math-converter.vala"
	position = _tmp3_;
#line 302 "../src/math-converter.vala"
	if (position == ((guint) -1)) {
#line 303 "../src/math-converter.vala"
		result = FALSE;
#line 303 "../src/math-converter.vala"
		_g_object_unref0 (model);
#line 303 "../src/math-converter.vala"
		return result;
#line 2139 "math-converter.c"
	}
#line 304 "../src/math-converter.vala"
	gtk_drop_down_set_selected (combo, position);
#line 305 "../src/math-converter.vala"
	result = TRUE;
#line 305 "../src/math-converter.vala"
	_g_object_unref0 (model);
#line 305 "../src/math-converter.vala"
	return result;
#line 2149 "math-converter.c"
}

static void
math_converter_category_combobox_changed_cb (MathConverter* self)
{
	UnitCategory* category = NULL;
	GtkDropDown* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	UnitCategory* _tmp3_;
	UnitCategory* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* source_currency = NULL;
	gchar* _tmp8_;
	gchar* target_currency = NULL;
	gchar* _tmp9_;
	MathEquation* _tmp10_;
	UnitCategory* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean _tmp21_;
#line 309 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 311 "../src/math-converter.vala"
	_tmp0_ = self->priv->category_combo;
#line 311 "../src/math-converter.vala"
	_tmp1_ = gtk_drop_down_get_selected_item (_tmp0_);
#line 311 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 311 "../src/math-converter.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) _tmp2_) : NULL);
#line 311 "../src/math-converter.vala"
	category = _tmp3_;
#line 313 "../src/math-converter.vala"
	_tmp4_ = category;
#line 313 "../src/math-converter.vala"
	_tmp5_ = unit_category_get_name (_tmp4_);
#line 313 "../src/math-converter.vala"
	_tmp6_ = _tmp5_;
#line 313 "../src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 313 "../src/math-converter.vala"
	self->priv->category = _tmp6_;
#line 315 "../src/math-converter.vala"
	math_converter_update_visibility (self);
#line 316 "../src/math-converter.vala"
	if (self->priv->from_combobox_changed > ((gulong) 0)) {
#line 2199 "math-converter.c"
		GtkDropDown* _tmp7_;
#line 317 "../src/math-converter.vala"
		_tmp7_ = self->priv->from_combo;
#line 317 "../src/math-converter.vala"
		g_signal_handler_block (_tmp7_, self->priv->from_combobox_changed);
#line 2205 "math-converter.c"
	}
#line 318 "../src/math-converter.vala"
	_tmp8_ = g_strdup ("");
#line 318 "../src/math-converter.vala"
	source_currency = _tmp8_;
#line 318 "../src/math-converter.vala"
	_tmp9_ = g_strdup ("");
#line 318 "../src/math-converter.vala"
	target_currency = _tmp9_;
#line 319 "../src/math-converter.vala"
	_tmp10_ = self->priv->_equation;
#line 319 "../src/math-converter.vala"
	if (_tmp10_ != NULL) {
#line 2219 "math-converter.c"
		MathEquation* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		MathEquation* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 321 "../src/math-converter.vala"
		_tmp11_ = self->priv->_equation;
#line 321 "../src/math-converter.vala"
		_tmp12_ = math_equation_get_source_currency (_tmp11_);
#line 321 "../src/math-converter.vala"
		_tmp13_ = _tmp12_;
#line 321 "../src/math-converter.vala"
		_g_free0 (source_currency);
#line 321 "../src/math-converter.vala"
		source_currency = _tmp13_;
#line 322 "../src/math-converter.vala"
		_tmp14_ = self->priv->_equation;
#line 322 "../src/math-converter.vala"
		_tmp15_ = math_equation_get_target_currency (_tmp14_);
#line 322 "../src/math-converter.vala"
		_tmp16_ = _tmp15_;
#line 322 "../src/math-converter.vala"
		_g_free0 (target_currency);
#line 322 "../src/math-converter.vala"
		target_currency = _tmp16_;
#line 2246 "math-converter.c"
	}
#line 324 "../src/math-converter.vala"
	math_converter_build_units_model (self);
#line 325 "../src/math-converter.vala"
	_tmp17_ = category;
#line 325 "../src/math-converter.vala"
	_tmp18_ = unit_category_get_name (_tmp17_);
#line 325 "../src/math-converter.vala"
	_tmp19_ = _tmp18_;
#line 325 "../src/math-converter.vala"
	_tmp20_ = _tmp19_;
#line 325 "../src/math-converter.vala"
	_tmp21_ = g_strcmp0 (_tmp20_, "currency") != 0;
#line 325 "../src/math-converter.vala"
	_g_free0 (_tmp20_);
#line 325 "../src/math-converter.vala"
	if (_tmp21_) {
#line 2264 "math-converter.c"
		GtkDropDown* _tmp22_;
#line 327 "../src/math-converter.vala"
		_tmp22_ = self->priv->from_combo;
#line 327 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp22_, (guint) 0);
#line 2270 "math-converter.c"
	} else {
		Unit* ua = NULL;
		UnitManager* _tmp23_;
		UnitManager* _tmp24_;
		const gchar* _tmp25_;
		Unit* _tmp26_;
		Unit* _tmp27_;
		Unit* ub = NULL;
		UnitManager* _tmp28_;
		UnitManager* _tmp29_;
		const gchar* _tmp30_;
		Unit* _tmp31_;
		Unit* _tmp32_;
		gboolean _tmp33_ = FALSE;
		Unit* _tmp34_;
#line 331 "../src/math-converter.vala"
		_tmp23_ = unit_manager_get_default ();
#line 331 "../src/math-converter.vala"
		_tmp24_ = _tmp23_;
#line 331 "../src/math-converter.vala"
		_tmp25_ = source_currency;
#line 331 "../src/math-converter.vala"
		_tmp26_ = unit_manager_get_unit_by_name (_tmp24_, _tmp25_);
#line 331 "../src/math-converter.vala"
		_tmp27_ = _tmp26_;
#line 331 "../src/math-converter.vala"
		_g_object_unref0 (_tmp24_);
#line 331 "../src/math-converter.vala"
		ua = _tmp27_;
#line 332 "../src/math-converter.vala"
		_tmp28_ = unit_manager_get_default ();
#line 332 "../src/math-converter.vala"
		_tmp29_ = _tmp28_;
#line 332 "../src/math-converter.vala"
		_tmp30_ = target_currency;
#line 332 "../src/math-converter.vala"
		_tmp31_ = unit_manager_get_unit_by_name (_tmp29_, _tmp30_);
#line 332 "../src/math-converter.vala"
		_tmp32_ = _tmp31_;
#line 332 "../src/math-converter.vala"
		_g_object_unref0 (_tmp29_);
#line 332 "../src/math-converter.vala"
		ub = _tmp32_;
#line 333 "../src/math-converter.vala"
		_tmp34_ = ua;
#line 333 "../src/math-converter.vala"
		if (_tmp34_ == NULL) {
#line 333 "../src/math-converter.vala"
			_tmp33_ = TRUE;
#line 2320 "math-converter.c"
		} else {
			Unit* _tmp35_;
#line 333 "../src/math-converter.vala"
			_tmp35_ = ub;
#line 333 "../src/math-converter.vala"
			_tmp33_ = _tmp35_ == NULL;
#line 2327 "math-converter.c"
		}
#line 333 "../src/math-converter.vala"
		if (_tmp33_) {
#line 2331 "math-converter.c"
			GtkDropDown* _tmp36_;
#line 335 "../src/math-converter.vala"
			_tmp36_ = self->priv->from_combo;
#line 335 "../src/math-converter.vala"
			gtk_drop_down_set_selected (_tmp36_, (guint) 0);
#line 2337 "math-converter.c"
		} else {
			GtkDropDown* _tmp37_;
			Unit* _tmp38_;
			GtkDropDown* _tmp39_;
			Unit* _tmp40_;
#line 339 "../src/math-converter.vala"
			_tmp37_ = self->priv->from_combo;
#line 339 "../src/math-converter.vala"
			_tmp38_ = ua;
#line 339 "../src/math-converter.vala"
			math_converter_set_active_unit (self, _tmp37_, _tmp38_);
#line 340 "../src/math-converter.vala"
			_tmp39_ = self->priv->to_combo;
#line 340 "../src/math-converter.vala"
			_tmp40_ = ub;
#line 340 "../src/math-converter.vala"
			math_converter_set_active_unit (self, _tmp39_, _tmp40_);
#line 2355 "math-converter.c"
		}
#line 325 "../src/math-converter.vala"
		_g_object_unref0 (ub);
#line 325 "../src/math-converter.vala"
		_g_object_unref0 (ua);
#line 2361 "math-converter.c"
	}
#line 343 "../src/math-converter.vala"
	if (self->priv->from_combobox_changed > ((gulong) 0)) {
#line 2365 "math-converter.c"
		GtkDropDown* _tmp41_;
#line 344 "../src/math-converter.vala"
		_tmp41_ = self->priv->from_combo;
#line 344 "../src/math-converter.vala"
		g_signal_handler_unblock (_tmp41_, self->priv->from_combobox_changed);
#line 2371 "math-converter.c"
	}
#line 345 "../src/math-converter.vala"
	math_converter_to_combobox_changed_cb (self);
#line 346 "../src/math-converter.vala"
	g_signal_emit (self, math_converter_signals[MATH_CONVERTER_CATEGORY_CHANGED_SIGNAL], 0);
#line 309 "../src/math-converter.vala"
	_g_free0 (target_currency);
#line 309 "../src/math-converter.vala"
	_g_free0 (source_currency);
#line 309 "../src/math-converter.vala"
	_g_object_unref0 (category);
#line 2383 "math-converter.c"
}

static void
_math_converter_category_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_category_combobox_changed_cb ((MathConverter*) self);
#line 2393 "math-converter.c"
}

static void
math_converter_from_combobox_changed_cb (MathConverter* self)
{
	Number* _tmp0_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp1_;
	Unit* _tmp2_ = NULL;
	Unit* _tmp3_ = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	GtkTextView* _tmp7_;
	GtkTextBuffer* _tmp8_;
	GtkTextBuffer* _tmp9_;
	GtkTextView* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	MathEquation* _tmp13_;
	Serializer* _tmp14_;
	Serializer* _tmp15_;
	Number* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GtkTextView* _tmp19_;
	GtkTextBuffer* _tmp20_;
	GtkTextBuffer* _tmp21_;
#line 349 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 351 "../src/math-converter.vala"
	_tmp0_ = self->priv->to_number;
#line 351 "../src/math-converter.vala"
	if (_tmp0_ == NULL) {
#line 352 "../src/math-converter.vala"
		return;
#line 2430 "math-converter.c"
	}
#line 354 "../src/math-converter.vala"
	_tmp1_ = self->priv->to_number;
#line 354 "../src/math-converter.vala"
	_tmp4_ = math_converter_convert_equation (self, _tmp1_, &_tmp2_, &_tmp3_);
#line 354 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 354 "../src/math-converter.vala"
	source_unit = _tmp2_;
#line 354 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 354 "../src/math-converter.vala"
	target_unit = _tmp3_;
#line 354 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 354 "../src/math-converter.vala"
	self->priv->from_number = _tmp4_;
#line 355 "../src/math-converter.vala"
	_tmp5_ = self->priv->from_number;
#line 355 "../src/math-converter.vala"
	if (_tmp5_ == NULL) {
#line 2452 "math-converter.c"
		Number* _tmp6_;
#line 356 "../src/math-converter.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 356 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->from_number);
#line 356 "../src/math-converter.vala"
		self->priv->from_number = _tmp6_;
#line 2460 "math-converter.c"
	}
#line 357 "../src/math-converter.vala"
	_tmp7_ = self->priv->from_entry;
#line 357 "../src/math-converter.vala"
	_tmp8_ = gtk_text_view_get_buffer (_tmp7_);
#line 357 "../src/math-converter.vala"
	_tmp9_ = _tmp8_;
#line 357 "../src/math-converter.vala"
	g_signal_handler_block (_tmp9_, self->priv->from_entry_changed);
#line 358 "../src/math-converter.vala"
	_tmp10_ = self->priv->from_entry;
#line 358 "../src/math-converter.vala"
	_tmp11_ = gtk_text_view_get_buffer (_tmp10_);
#line 358 "../src/math-converter.vala"
	_tmp12_ = _tmp11_;
#line 358 "../src/math-converter.vala"
	_tmp13_ = self->priv->_equation;
#line 358 "../src/math-converter.vala"
	_tmp14_ = math_equation_get_serializer (_tmp13_);
#line 358 "../src/math-converter.vala"
	_tmp15_ = _tmp14_;
#line 358 "../src/math-converter.vala"
	_tmp16_ = self->priv->from_number;
#line 358 "../src/math-converter.vala"
	_tmp17_ = serializer_to_string (_tmp15_, _tmp16_);
#line 358 "../src/math-converter.vala"
	_tmp18_ = _tmp17_;
#line 358 "../src/math-converter.vala"
	g_object_set (_tmp12_, "text", _tmp18_, NULL);
#line 358 "../src/math-converter.vala"
	_g_free0 (_tmp18_);
#line 359 "../src/math-converter.vala"
	_tmp19_ = self->priv->from_entry;
#line 359 "../src/math-converter.vala"
	_tmp20_ = gtk_text_view_get_buffer (_tmp19_);
#line 359 "../src/math-converter.vala"
	_tmp21_ = _tmp20_;
#line 359 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp21_, self->priv->from_entry_changed);
#line 360 "../src/math-converter.vala"
	math_converter_save_selected_units (self);
#line 349 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 349 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 2506 "math-converter.c"
}

static void
math_converter_to_combobox_changed_cb (MathConverter* self)
{
	Number* _tmp0_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp1_;
	Unit* _tmp2_ = NULL;
	Unit* _tmp3_ = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	GtkTextView* _tmp7_;
	GtkTextBuffer* _tmp8_;
	GtkTextBuffer* _tmp9_;
	GtkTextView* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	GtkTextView* _tmp29_;
	GtkTextBuffer* _tmp30_;
	GtkTextBuffer* _tmp31_;
#line 364 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 366 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_number;
#line 366 "../src/math-converter.vala"
	if (_tmp0_ == NULL) {
#line 367 "../src/math-converter.vala"
		return;
#line 2537 "math-converter.c"
	}
#line 369 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_number;
#line 369 "../src/math-converter.vala"
	_tmp4_ = math_converter_convert_equation (self, _tmp1_, &_tmp2_, &_tmp3_);
#line 369 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 369 "../src/math-converter.vala"
	source_unit = _tmp2_;
#line 369 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 369 "../src/math-converter.vala"
	target_unit = _tmp3_;
#line 369 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 369 "../src/math-converter.vala"
	self->priv->to_number = _tmp4_;
#line 370 "../src/math-converter.vala"
	_tmp5_ = self->priv->to_number;
#line 370 "../src/math-converter.vala"
	if (_tmp5_ == NULL) {
#line 2559 "math-converter.c"
		Number* _tmp6_;
#line 371 "../src/math-converter.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 371 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->to_number);
#line 371 "../src/math-converter.vala"
		self->priv->to_number = _tmp6_;
#line 2567 "math-converter.c"
	}
#line 372 "../src/math-converter.vala"
	_tmp7_ = self->priv->to_entry;
#line 372 "../src/math-converter.vala"
	_tmp8_ = gtk_text_view_get_buffer (_tmp7_);
#line 372 "../src/math-converter.vala"
	_tmp9_ = _tmp8_;
#line 372 "../src/math-converter.vala"
	g_signal_handler_block (_tmp9_, self->priv->to_entry_changed);
#line 373 "../src/math-converter.vala"
	_tmp10_ = self->priv->to_entry;
#line 373 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp10_, "has-focus", &_tmp11_, NULL);
#line 373 "../src/math-converter.vala"
	_tmp12_ = _tmp11_;
#line 373 "../src/math-converter.vala"
	if (_tmp12_) {
#line 2585 "math-converter.c"
		GtkTextView* _tmp13_;
		GtkTextBuffer* _tmp14_;
		GtkTextBuffer* _tmp15_;
		Serializer* _tmp16_;
		Number* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 374 "../src/math-converter.vala"
		_tmp13_ = self->priv->to_entry;
#line 374 "../src/math-converter.vala"
		_tmp14_ = gtk_text_view_get_buffer (_tmp13_);
#line 374 "../src/math-converter.vala"
		_tmp15_ = _tmp14_;
#line 374 "../src/math-converter.vala"
		_tmp16_ = self->priv->fixed_serializer;
#line 374 "../src/math-converter.vala"
		_tmp17_ = self->priv->to_number;
#line 374 "../src/math-converter.vala"
		_tmp18_ = serializer_to_string (_tmp16_, _tmp17_);
#line 374 "../src/math-converter.vala"
		_tmp19_ = _tmp18_;
#line 374 "../src/math-converter.vala"
		g_object_set (_tmp15_, "text", _tmp19_, NULL);
#line 374 "../src/math-converter.vala"
		_g_free0 (_tmp19_);
#line 2611 "math-converter.c"
	} else {
		GtkTextView* _tmp20_;
		GtkTextBuffer* _tmp21_;
		GtkTextBuffer* _tmp22_;
		MathEquation* _tmp23_;
		Serializer* _tmp24_;
		Serializer* _tmp25_;
		Number* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
#line 376 "../src/math-converter.vala"
		_tmp20_ = self->priv->to_entry;
#line 376 "../src/math-converter.vala"
		_tmp21_ = gtk_text_view_get_buffer (_tmp20_);
#line 376 "../src/math-converter.vala"
		_tmp22_ = _tmp21_;
#line 376 "../src/math-converter.vala"
		_tmp23_ = self->priv->_equation;
#line 376 "../src/math-converter.vala"
		_tmp24_ = math_equation_get_serializer (_tmp23_);
#line 376 "../src/math-converter.vala"
		_tmp25_ = _tmp24_;
#line 376 "../src/math-converter.vala"
		_tmp26_ = self->priv->to_number;
#line 376 "../src/math-converter.vala"
		_tmp27_ = serializer_to_string (_tmp25_, _tmp26_);
#line 376 "../src/math-converter.vala"
		_tmp28_ = _tmp27_;
#line 376 "../src/math-converter.vala"
		g_object_set (_tmp22_, "text", _tmp28_, NULL);
#line 376 "../src/math-converter.vala"
		_g_free0 (_tmp28_);
#line 2644 "math-converter.c"
	}
#line 377 "../src/math-converter.vala"
	_tmp29_ = self->priv->to_entry;
#line 377 "../src/math-converter.vala"
	_tmp30_ = gtk_text_view_get_buffer (_tmp29_);
#line 377 "../src/math-converter.vala"
	_tmp31_ = _tmp30_;
#line 377 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp31_, self->priv->to_entry_changed);
#line 378 "../src/math-converter.vala"
	math_converter_save_selected_units (self);
#line 364 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 364 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 2660 "math-converter.c"
}

static void
_math_converter_to_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_to_combobox_changed_cb ((MathConverter*) self);
#line 2670 "math-converter.c"
}

static void
math_converter_save_selected_units (MathConverter* self)
{
	Unit* from_unit = NULL;
	Unit* to_unit = NULL;
	Unit* _tmp0_ = NULL;
	Unit* _tmp1_ = NULL;
	const gchar* _tmp2_;
	MathEquation* _tmp13_;
	Unit* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	MathEquation* _tmp18_;
	Unit* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
#line 381 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 384 "../src/math-converter.vala"
	math_converter_get_conversion (self, &_tmp0_, &_tmp1_);
#line 384 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 384 "../src/math-converter.vala"
	from_unit = _tmp0_;
#line 384 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 384 "../src/math-converter.vala"
	to_unit = _tmp1_;
#line 385 "../src/math-converter.vala"
	_tmp2_ = self->priv->category;
#line 385 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp2_, "currency") == 0) {
#line 2707 "math-converter.c"
		MathEquation* _tmp3_;
		Unit* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		MathEquation* _tmp8_;
		Unit* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 387 "../src/math-converter.vala"
		_tmp3_ = self->priv->_equation;
#line 387 "../src/math-converter.vala"
		_tmp4_ = from_unit;
#line 387 "../src/math-converter.vala"
		_tmp5_ = unit_get_name (_tmp4_);
#line 387 "../src/math-converter.vala"
		_tmp6_ = _tmp5_;
#line 387 "../src/math-converter.vala"
		_tmp7_ = _tmp6_;
#line 387 "../src/math-converter.vala"
		math_equation_set_source_currency (_tmp3_, _tmp7_);
#line 387 "../src/math-converter.vala"
		_g_free0 (_tmp7_);
#line 388 "../src/math-converter.vala"
		_tmp8_ = self->priv->_equation;
#line 388 "../src/math-converter.vala"
		_tmp9_ = to_unit;
#line 388 "../src/math-converter.vala"
		_tmp10_ = unit_get_name (_tmp9_);
#line 388 "../src/math-converter.vala"
		_tmp11_ = _tmp10_;
#line 388 "../src/math-converter.vala"
		_tmp12_ = _tmp11_;
#line 388 "../src/math-converter.vala"
		math_equation_set_target_currency (_tmp8_, _tmp12_);
#line 388 "../src/math-converter.vala"
		_g_free0 (_tmp12_);
#line 2746 "math-converter.c"
	}
#line 390 "../src/math-converter.vala"
	_tmp13_ = self->priv->_equation;
#line 390 "../src/math-converter.vala"
	_tmp14_ = from_unit;
#line 390 "../src/math-converter.vala"
	_tmp15_ = unit_get_name (_tmp14_);
#line 390 "../src/math-converter.vala"
	_tmp16_ = _tmp15_;
#line 390 "../src/math-converter.vala"
	_tmp17_ = _tmp16_;
#line 390 "../src/math-converter.vala"
	math_equation_set_source_units (_tmp13_, _tmp17_);
#line 390 "../src/math-converter.vala"
	_g_free0 (_tmp17_);
#line 391 "../src/math-converter.vala"
	_tmp18_ = self->priv->_equation;
#line 391 "../src/math-converter.vala"
	_tmp19_ = to_unit;
#line 391 "../src/math-converter.vala"
	_tmp20_ = unit_get_name (_tmp19_);
#line 391 "../src/math-converter.vala"
	_tmp21_ = _tmp20_;
#line 391 "../src/math-converter.vala"
	_tmp22_ = _tmp21_;
#line 391 "../src/math-converter.vala"
	math_equation_set_target_units (_tmp18_, _tmp22_);
#line 391 "../src/math-converter.vala"
	_g_free0 (_tmp22_);
#line 381 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 381 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 2780 "math-converter.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 2801 "math-converter.c"
}

static void
math_converter_from_entry_focus_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextView* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkTextView* _tmp33_;
	GtkTextBuffer* _tmp34_;
	GtkTextBuffer* _tmp35_;
#line 395 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 397 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_entry;
#line 397 "../src/math-converter.vala"
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
#line 397 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 397 "../src/math-converter.vala"
	g_signal_handler_block (_tmp2_, self->priv->from_entry_changed);
#line 398 "../src/math-converter.vala"
	_tmp3_ = self->priv->from_entry;
#line 398 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp3_, "has-focus", &_tmp4_, NULL);
#line 398 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 398 "../src/math-converter.vala"
	if (_tmp5_) {
#line 2834 "math-converter.c"
		GtkTextView* _tmp6_;
		GtkTextBuffer* _tmp7_;
		GtkTextBuffer* _tmp8_;
		Serializer* _tmp9_;
		Number* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 400 "../src/math-converter.vala"
		_tmp6_ = self->priv->from_entry;
#line 400 "../src/math-converter.vala"
		_tmp7_ = gtk_text_view_get_buffer (_tmp6_);
#line 400 "../src/math-converter.vala"
		_tmp8_ = _tmp7_;
#line 400 "../src/math-converter.vala"
		_tmp9_ = self->priv->fixed_serializer;
#line 400 "../src/math-converter.vala"
		_tmp10_ = self->priv->from_number;
#line 400 "../src/math-converter.vala"
		_tmp11_ = serializer_to_string (_tmp9_, _tmp10_);
#line 400 "../src/math-converter.vala"
		_tmp12_ = _tmp11_;
#line 400 "../src/math-converter.vala"
		g_object_set (_tmp8_, "text", _tmp12_, NULL);
#line 400 "../src/math-converter.vala"
		_g_free0 (_tmp12_);
#line 2860 "math-converter.c"
	} else {
		GtkTextView* _tmp13_;
		GtkTextBuffer* _tmp14_;
		GtkTextBuffer* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		GtkTextView* _tmp24_;
		GtkTextBuffer* _tmp25_;
		GtkTextBuffer* _tmp26_;
		MathEquation* _tmp27_;
		Serializer* _tmp28_;
		Serializer* _tmp29_;
		Number* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
#line 404 "../src/math-converter.vala"
		_tmp13_ = self->priv->from_entry;
#line 404 "../src/math-converter.vala"
		_tmp14_ = gtk_text_view_get_buffer (_tmp13_);
#line 404 "../src/math-converter.vala"
		_tmp15_ = _tmp14_;
#line 404 "../src/math-converter.vala"
		g_object_get (_tmp15_, "text", &_tmp16_, NULL);
#line 404 "../src/math-converter.vala"
		_tmp17_ = _tmp16_;
#line 404 "../src/math-converter.vala"
		_tmp18_ = _tmp17_;
#line 404 "../src/math-converter.vala"
		_tmp19_ = string_strip (_tmp18_);
#line 404 "../src/math-converter.vala"
		_tmp20_ = _tmp19_;
#line 404 "../src/math-converter.vala"
		_tmp21_ = math_converter_get_number_from_string (self, _tmp20_);
#line 404 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->from_number);
#line 404 "../src/math-converter.vala"
		self->priv->from_number = _tmp21_;
#line 404 "../src/math-converter.vala"
		_g_free0 (_tmp20_);
#line 404 "../src/math-converter.vala"
		_g_free0 (_tmp18_);
#line 405 "../src/math-converter.vala"
		_tmp22_ = self->priv->from_number;
#line 405 "../src/math-converter.vala"
		if (_tmp22_ == NULL) {
#line 2911 "math-converter.c"
			Number* _tmp23_;
#line 406 "../src/math-converter.vala"
			_tmp23_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 406 "../src/math-converter.vala"
			_g_object_unref0 (self->priv->from_number);
#line 406 "../src/math-converter.vala"
			self->priv->from_number = _tmp23_;
#line 2919 "math-converter.c"
		}
#line 407 "../src/math-converter.vala"
		_tmp24_ = self->priv->from_entry;
#line 407 "../src/math-converter.vala"
		_tmp25_ = gtk_text_view_get_buffer (_tmp24_);
#line 407 "../src/math-converter.vala"
		_tmp26_ = _tmp25_;
#line 407 "../src/math-converter.vala"
		_tmp27_ = self->priv->_equation;
#line 407 "../src/math-converter.vala"
		_tmp28_ = math_equation_get_serializer (_tmp27_);
#line 407 "../src/math-converter.vala"
		_tmp29_ = _tmp28_;
#line 407 "../src/math-converter.vala"
		_tmp30_ = self->priv->from_number;
#line 407 "../src/math-converter.vala"
		_tmp31_ = serializer_to_string (_tmp29_, _tmp30_);
#line 407 "../src/math-converter.vala"
		_tmp32_ = _tmp31_;
#line 407 "../src/math-converter.vala"
		g_object_set (_tmp26_, "text", _tmp32_, NULL);
#line 407 "../src/math-converter.vala"
		_g_free0 (_tmp32_);
#line 2943 "math-converter.c"
	}
#line 409 "../src/math-converter.vala"
	_tmp33_ = self->priv->from_entry;
#line 409 "../src/math-converter.vala"
	_tmp34_ = gtk_text_view_get_buffer (_tmp33_);
#line 409 "../src/math-converter.vala"
	_tmp35_ = _tmp34_;
#line 409 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp35_, self->priv->from_entry_changed);
#line 2953 "math-converter.c"
}

static void
_math_converter_from_entry_focus_cb_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_from_entry_focus_cb ((MathConverter*) self);
#line 2963 "math-converter.c"
}

static void
math_converter_to_entry_focus_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextView* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkTextView* _tmp33_;
	GtkTextBuffer* _tmp34_;
	GtkTextBuffer* _tmp35_;
#line 413 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 415 "../src/math-converter.vala"
	_tmp0_ = self->priv->to_entry;
#line 415 "../src/math-converter.vala"
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
#line 415 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 415 "../src/math-converter.vala"
	g_signal_handler_block (_tmp2_, self->priv->to_entry_changed);
#line 416 "../src/math-converter.vala"
	_tmp3_ = self->priv->to_entry;
#line 416 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp3_, "has-focus", &_tmp4_, NULL);
#line 416 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 416 "../src/math-converter.vala"
	if (_tmp5_) {
#line 2996 "math-converter.c"
		GtkTextView* _tmp6_;
		GtkTextBuffer* _tmp7_;
		GtkTextBuffer* _tmp8_;
		Serializer* _tmp9_;
		Number* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 418 "../src/math-converter.vala"
		_tmp6_ = self->priv->to_entry;
#line 418 "../src/math-converter.vala"
		_tmp7_ = gtk_text_view_get_buffer (_tmp6_);
#line 418 "../src/math-converter.vala"
		_tmp8_ = _tmp7_;
#line 418 "../src/math-converter.vala"
		_tmp9_ = self->priv->fixed_serializer;
#line 418 "../src/math-converter.vala"
		_tmp10_ = self->priv->to_number;
#line 418 "../src/math-converter.vala"
		_tmp11_ = serializer_to_string (_tmp9_, _tmp10_);
#line 418 "../src/math-converter.vala"
		_tmp12_ = _tmp11_;
#line 418 "../src/math-converter.vala"
		g_object_set (_tmp8_, "text", _tmp12_, NULL);
#line 418 "../src/math-converter.vala"
		_g_free0 (_tmp12_);
#line 3022 "math-converter.c"
	} else {
		GtkTextView* _tmp13_;
		GtkTextBuffer* _tmp14_;
		GtkTextBuffer* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		GtkTextView* _tmp24_;
		GtkTextBuffer* _tmp25_;
		GtkTextBuffer* _tmp26_;
		MathEquation* _tmp27_;
		Serializer* _tmp28_;
		Serializer* _tmp29_;
		Number* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
#line 422 "../src/math-converter.vala"
		_tmp13_ = self->priv->to_entry;
#line 422 "../src/math-converter.vala"
		_tmp14_ = gtk_text_view_get_buffer (_tmp13_);
#line 422 "../src/math-converter.vala"
		_tmp15_ = _tmp14_;
#line 422 "../src/math-converter.vala"
		g_object_get (_tmp15_, "text", &_tmp16_, NULL);
#line 422 "../src/math-converter.vala"
		_tmp17_ = _tmp16_;
#line 422 "../src/math-converter.vala"
		_tmp18_ = _tmp17_;
#line 422 "../src/math-converter.vala"
		_tmp19_ = string_strip (_tmp18_);
#line 422 "../src/math-converter.vala"
		_tmp20_ = _tmp19_;
#line 422 "../src/math-converter.vala"
		_tmp21_ = math_converter_get_number_from_string (self, _tmp20_);
#line 422 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->to_number);
#line 422 "../src/math-converter.vala"
		self->priv->to_number = _tmp21_;
#line 422 "../src/math-converter.vala"
		_g_free0 (_tmp20_);
#line 422 "../src/math-converter.vala"
		_g_free0 (_tmp18_);
#line 423 "../src/math-converter.vala"
		_tmp22_ = self->priv->to_number;
#line 423 "../src/math-converter.vala"
		if (_tmp22_ == NULL) {
#line 3073 "math-converter.c"
			Number* _tmp23_;
#line 424 "../src/math-converter.vala"
			_tmp23_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 424 "../src/math-converter.vala"
			_g_object_unref0 (self->priv->to_number);
#line 424 "../src/math-converter.vala"
			self->priv->to_number = _tmp23_;
#line 3081 "math-converter.c"
		}
#line 425 "../src/math-converter.vala"
		_tmp24_ = self->priv->to_entry;
#line 425 "../src/math-converter.vala"
		_tmp25_ = gtk_text_view_get_buffer (_tmp24_);
#line 425 "../src/math-converter.vala"
		_tmp26_ = _tmp25_;
#line 425 "../src/math-converter.vala"
		_tmp27_ = self->priv->_equation;
#line 425 "../src/math-converter.vala"
		_tmp28_ = math_equation_get_serializer (_tmp27_);
#line 425 "../src/math-converter.vala"
		_tmp29_ = _tmp28_;
#line 425 "../src/math-converter.vala"
		_tmp30_ = self->priv->to_number;
#line 425 "../src/math-converter.vala"
		_tmp31_ = serializer_to_string (_tmp29_, _tmp30_);
#line 425 "../src/math-converter.vala"
		_tmp32_ = _tmp31_;
#line 425 "../src/math-converter.vala"
		g_object_set (_tmp26_, "text", _tmp32_, NULL);
#line 425 "../src/math-converter.vala"
		_g_free0 (_tmp32_);
#line 3105 "math-converter.c"
	}
#line 427 "../src/math-converter.vala"
	_tmp33_ = self->priv->to_entry;
#line 427 "../src/math-converter.vala"
	_tmp34_ = gtk_text_view_get_buffer (_tmp33_);
#line 427 "../src/math-converter.vala"
	_tmp35_ = _tmp34_;
#line 427 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp35_, self->priv->to_entry_changed);
#line 3115 "math-converter.c"
}

static void
_math_converter_to_entry_focus_cb_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_to_entry_focus_cb ((MathConverter*) self);
#line 3125 "math-converter.c"
}

static void
math_converter_from_entry_changed_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp11_;
	Unit* _tmp12_ = NULL;
	Unit* _tmp13_ = NULL;
	Number* _tmp14_;
	Number* _tmp15_;
	GtkTextView* _tmp17_;
	GtkTextBuffer* _tmp18_;
	GtkTextBuffer* _tmp19_;
	GtkTextView* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	GtkTextView* _tmp39_;
	GtkTextBuffer* _tmp40_;
	GtkTextBuffer* _tmp41_;
#line 430 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 432 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_entry;
#line 432 "../src/math-converter.vala"
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
#line 432 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 432 "../src/math-converter.vala"
	g_object_get (_tmp2_, "text", &_tmp3_, NULL);
#line 432 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 432 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 432 "../src/math-converter.vala"
	_tmp6_ = string_strip (_tmp5_);
#line 432 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 432 "../src/math-converter.vala"
	_tmp8_ = math_converter_get_number_from_string (self, _tmp7_);
#line 432 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 432 "../src/math-converter.vala"
	self->priv->from_number = _tmp8_;
#line 432 "../src/math-converter.vala"
	_g_free0 (_tmp7_);
#line 432 "../src/math-converter.vala"
	_g_free0 (_tmp5_);
#line 433 "../src/math-converter.vala"
	_tmp9_ = self->priv->from_number;
#line 433 "../src/math-converter.vala"
	if (_tmp9_ == NULL) {
#line 3189 "math-converter.c"
		Number* _tmp10_;
#line 434 "../src/math-converter.vala"
		_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 434 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->from_number);
#line 434 "../src/math-converter.vala"
		self->priv->from_number = _tmp10_;
#line 3197 "math-converter.c"
	}
#line 436 "../src/math-converter.vala"
	_tmp11_ = self->priv->from_number;
#line 436 "../src/math-converter.vala"
	_tmp14_ = math_converter_convert_equation (self, _tmp11_, &_tmp12_, &_tmp13_);
#line 436 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 436 "../src/math-converter.vala"
	source_unit = _tmp12_;
#line 436 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 436 "../src/math-converter.vala"
	target_unit = _tmp13_;
#line 436 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 436 "../src/math-converter.vala"
	self->priv->to_number = _tmp14_;
#line 437 "../src/math-converter.vala"
	_tmp15_ = self->priv->to_number;
#line 437 "../src/math-converter.vala"
	if (_tmp15_ == NULL) {
#line 3219 "math-converter.c"
		Number* _tmp16_;
#line 438 "../src/math-converter.vala"
		_tmp16_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 438 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->to_number);
#line 438 "../src/math-converter.vala"
		self->priv->to_number = _tmp16_;
#line 3227 "math-converter.c"
	}
#line 439 "../src/math-converter.vala"
	_tmp17_ = self->priv->to_entry;
#line 439 "../src/math-converter.vala"
	_tmp18_ = gtk_text_view_get_buffer (_tmp17_);
#line 439 "../src/math-converter.vala"
	_tmp19_ = _tmp18_;
#line 439 "../src/math-converter.vala"
	g_signal_handler_block (_tmp19_, self->priv->to_entry_changed);
#line 440 "../src/math-converter.vala"
	_tmp20_ = self->priv->to_entry;
#line 440 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp20_, "has-focus", &_tmp21_, NULL);
#line 440 "../src/math-converter.vala"
	_tmp22_ = _tmp21_;
#line 440 "../src/math-converter.vala"
	if (_tmp22_) {
#line 3245 "math-converter.c"
		GtkTextView* _tmp23_;
		GtkTextBuffer* _tmp24_;
		GtkTextBuffer* _tmp25_;
		Serializer* _tmp26_;
		Number* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 441 "../src/math-converter.vala"
		_tmp23_ = self->priv->to_entry;
#line 441 "../src/math-converter.vala"
		_tmp24_ = gtk_text_view_get_buffer (_tmp23_);
#line 441 "../src/math-converter.vala"
		_tmp25_ = _tmp24_;
#line 441 "../src/math-converter.vala"
		_tmp26_ = self->priv->fixed_serializer;
#line 441 "../src/math-converter.vala"
		_tmp27_ = self->priv->to_number;
#line 441 "../src/math-converter.vala"
		_tmp28_ = serializer_to_string (_tmp26_, _tmp27_);
#line 441 "../src/math-converter.vala"
		_tmp29_ = _tmp28_;
#line 441 "../src/math-converter.vala"
		g_object_set (_tmp25_, "text", _tmp29_, NULL);
#line 441 "../src/math-converter.vala"
		_g_free0 (_tmp29_);
#line 3271 "math-converter.c"
	} else {
		GtkTextView* _tmp30_;
		GtkTextBuffer* _tmp31_;
		GtkTextBuffer* _tmp32_;
		MathEquation* _tmp33_;
		Serializer* _tmp34_;
		Serializer* _tmp35_;
		Number* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
#line 443 "../src/math-converter.vala"
		_tmp30_ = self->priv->to_entry;
#line 443 "../src/math-converter.vala"
		_tmp31_ = gtk_text_view_get_buffer (_tmp30_);
#line 443 "../src/math-converter.vala"
		_tmp32_ = _tmp31_;
#line 443 "../src/math-converter.vala"
		_tmp33_ = self->priv->_equation;
#line 443 "../src/math-converter.vala"
		_tmp34_ = math_equation_get_serializer (_tmp33_);
#line 443 "../src/math-converter.vala"
		_tmp35_ = _tmp34_;
#line 443 "../src/math-converter.vala"
		_tmp36_ = self->priv->to_number;
#line 443 "../src/math-converter.vala"
		_tmp37_ = serializer_to_string (_tmp35_, _tmp36_);
#line 443 "../src/math-converter.vala"
		_tmp38_ = _tmp37_;
#line 443 "../src/math-converter.vala"
		g_object_set (_tmp32_, "text", _tmp38_, NULL);
#line 443 "../src/math-converter.vala"
		_g_free0 (_tmp38_);
#line 3304 "math-converter.c"
	}
#line 444 "../src/math-converter.vala"
	_tmp39_ = self->priv->to_entry;
#line 444 "../src/math-converter.vala"
	_tmp40_ = gtk_text_view_get_buffer (_tmp39_);
#line 444 "../src/math-converter.vala"
	_tmp41_ = _tmp40_;
#line 444 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp41_, self->priv->to_entry_changed);
#line 430 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 430 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 3318 "math-converter.c"
}

static void
math_converter_to_entry_changed_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp11_;
	Unit* _tmp12_ = NULL;
	Unit* _tmp13_ = NULL;
	Number* _tmp14_;
	Number* _tmp15_;
	GtkTextView* _tmp17_;
	GtkTextBuffer* _tmp18_;
	GtkTextBuffer* _tmp19_;
	GtkTextView* _tmp20_;
	GtkTextBuffer* _tmp21_;
	GtkTextBuffer* _tmp22_;
	MathEquation* _tmp23_;
	Serializer* _tmp24_;
	Serializer* _tmp25_;
	Number* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GtkTextView* _tmp29_;
	GtkTextBuffer* _tmp30_;
	GtkTextBuffer* _tmp31_;
#line 447 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/math-converter.vala"
	_tmp0_ = self->priv->to_entry;
#line 449 "../src/math-converter.vala"
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
#line 449 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 449 "../src/math-converter.vala"
	g_object_get (_tmp2_, "text", &_tmp3_, NULL);
#line 449 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 449 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 449 "../src/math-converter.vala"
	_tmp6_ = string_strip (_tmp5_);
#line 449 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 449 "../src/math-converter.vala"
	_tmp8_ = math_converter_get_number_from_string (self, _tmp7_);
#line 449 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 449 "../src/math-converter.vala"
	self->priv->to_number = _tmp8_;
#line 449 "../src/math-converter.vala"
	_g_free0 (_tmp7_);
#line 449 "../src/math-converter.vala"
	_g_free0 (_tmp5_);
#line 450 "../src/math-converter.vala"
	_tmp9_ = self->priv->to_number;
#line 450 "../src/math-converter.vala"
	if (_tmp9_ == NULL) {
#line 3388 "math-converter.c"
		Number* _tmp10_;
#line 451 "../src/math-converter.vala"
		_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 451 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->to_number);
#line 451 "../src/math-converter.vala"
		self->priv->to_number = _tmp10_;
#line 3396 "math-converter.c"
	}
#line 453 "../src/math-converter.vala"
	_tmp11_ = self->priv->to_number;
#line 453 "../src/math-converter.vala"
	_tmp14_ = math_converter_convert_equation (self, _tmp11_, &_tmp12_, &_tmp13_);
#line 453 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 453 "../src/math-converter.vala"
	source_unit = _tmp12_;
#line 453 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 453 "../src/math-converter.vala"
	target_unit = _tmp13_;
#line 453 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 453 "../src/math-converter.vala"
	self->priv->from_number = _tmp14_;
#line 454 "../src/math-converter.vala"
	_tmp15_ = self->priv->from_number;
#line 454 "../src/math-converter.vala"
	if (_tmp15_ == NULL) {
#line 3418 "math-converter.c"
		Number* _tmp16_;
#line 455 "../src/math-converter.vala"
		_tmp16_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 455 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->from_number);
#line 455 "../src/math-converter.vala"
		self->priv->from_number = _tmp16_;
#line 3426 "math-converter.c"
	}
#line 456 "../src/math-converter.vala"
	_tmp17_ = self->priv->from_entry;
#line 456 "../src/math-converter.vala"
	_tmp18_ = gtk_text_view_get_buffer (_tmp17_);
#line 456 "../src/math-converter.vala"
	_tmp19_ = _tmp18_;
#line 456 "../src/math-converter.vala"
	g_signal_handler_block (_tmp19_, self->priv->from_entry_changed);
#line 457 "../src/math-converter.vala"
	_tmp20_ = self->priv->from_entry;
#line 457 "../src/math-converter.vala"
	_tmp21_ = gtk_text_view_get_buffer (_tmp20_);
#line 457 "../src/math-converter.vala"
	_tmp22_ = _tmp21_;
#line 457 "../src/math-converter.vala"
	_tmp23_ = self->priv->_equation;
#line 457 "../src/math-converter.vala"
	_tmp24_ = math_equation_get_serializer (_tmp23_);
#line 457 "../src/math-converter.vala"
	_tmp25_ = _tmp24_;
#line 457 "../src/math-converter.vala"
	_tmp26_ = self->priv->from_number;
#line 457 "../src/math-converter.vala"
	_tmp27_ = serializer_to_string (_tmp25_, _tmp26_);
#line 457 "../src/math-converter.vala"
	_tmp28_ = _tmp27_;
#line 457 "../src/math-converter.vala"
	g_object_set (_tmp22_, "text", _tmp28_, NULL);
#line 457 "../src/math-converter.vala"
	_g_free0 (_tmp28_);
#line 458 "../src/math-converter.vala"
	_tmp29_ = self->priv->from_entry;
#line 458 "../src/math-converter.vala"
	_tmp30_ = gtk_text_view_get_buffer (_tmp29_);
#line 458 "../src/math-converter.vala"
	_tmp31_ = _tmp30_;
#line 458 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp31_, self->priv->from_entry_changed);
#line 447 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 447 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 3470 "math-converter.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 3497 "math-converter.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 3503 "math-converter.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 3509 "math-converter.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 3513 "math-converter.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 3521 "math-converter.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 3525 "math-converter.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 3537 "math-converter.c"
}

static Number*
math_converter_get_number_from_string (MathConverter* self,
                                       const gchar* str)
{
	gboolean _tmp1_ = FALSE;
	Serializer* _tmp19_;
	Number* _tmp20_;
	Number* result;
#line 461 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 461 "../src/math-converter.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 463 "../src/math-converter.vala"
	if (g_strcmp0 (str, "π") == 0) {
#line 3554 "math-converter.c"
		Number* _tmp0_;
#line 464 "../src/math-converter.vala"
		_tmp0_ = number_new_pi ();
#line 464 "../src/math-converter.vala"
		result = _tmp0_;
#line 464 "../src/math-converter.vala"
		return result;
#line 3562 "math-converter.c"
	}
#line 465 "../src/math-converter.vala"
	if (g_strcmp0 (str, "−π") == 0) {
#line 465 "../src/math-converter.vala"
		_tmp1_ = TRUE;
#line 3568 "math-converter.c"
	} else {
#line 465 "../src/math-converter.vala"
		_tmp1_ = g_strcmp0 (str, "-π") == 0;
#line 3572 "math-converter.c"
	}
#line 465 "../src/math-converter.vala"
	if (_tmp1_) {
#line 3576 "math-converter.c"
		Number* _tmp2_;
		Number* _tmp3_;
		Number* _tmp4_;
		Number* _tmp5_;
#line 466 "../src/math-converter.vala"
		_tmp2_ = number_new_pi ();
#line 466 "../src/math-converter.vala"
		_tmp3_ = _tmp2_;
#line 466 "../src/math-converter.vala"
		_tmp4_ = number_invert_sign (_tmp3_);
#line 466 "../src/math-converter.vala"
		_tmp5_ = _tmp4_;
#line 466 "../src/math-converter.vala"
		_g_object_unref0 (_tmp3_);
#line 466 "../src/math-converter.vala"
		result = _tmp5_;
#line 466 "../src/math-converter.vala"
		return result;
#line 3595 "math-converter.c"
	}
#line 467 "../src/math-converter.vala"
	if (g_str_has_suffix (str, "π")) {
#line 3599 "math-converter.c"
		Number* number = NULL;
		Serializer* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		Number* _tmp11_;
		Number* _tmp12_;
		Number* _tmp13_;
		Number* _tmp14_;
		Number* _tmp15_;
		Number* _tmp16_;
		Number* _tmp17_;
		Number* _tmp18_;
#line 469 "../src/math-converter.vala"
		_tmp6_ = self->priv->fixed_serializer;
#line 469 "../src/math-converter.vala"
		_tmp7_ = strlen ("π");
#line 469 "../src/math-converter.vala"
		_tmp8_ = _tmp7_;
#line 469 "../src/math-converter.vala"
		_tmp9_ = string_slice (str, (glong) 0, (glong) (-_tmp8_));
#line 469 "../src/math-converter.vala"
		_tmp10_ = _tmp9_;
#line 469 "../src/math-converter.vala"
		_tmp11_ = serializer_from_string (_tmp6_, _tmp10_);
#line 469 "../src/math-converter.vala"
		_tmp12_ = _tmp11_;
#line 469 "../src/math-converter.vala"
		_g_free0 (_tmp10_);
#line 469 "../src/math-converter.vala"
		number = _tmp12_;
#line 470 "../src/math-converter.vala"
		_tmp13_ = number;
#line 470 "../src/math-converter.vala"
		if (_tmp13_ == NULL) {
#line 471 "../src/math-converter.vala"
			result = NULL;
#line 471 "../src/math-converter.vala"
			_g_object_unref0 (number);
#line 471 "../src/math-converter.vala"
			return result;
#line 3642 "math-converter.c"
		}
#line 472 "../src/math-converter.vala"
		_tmp14_ = number_new_pi ();
#line 472 "../src/math-converter.vala"
		_tmp15_ = _tmp14_;
#line 472 "../src/math-converter.vala"
		_tmp16_ = number;
#line 472 "../src/math-converter.vala"
		_tmp17_ = number_multiply (_tmp15_, _tmp16_);
#line 472 "../src/math-converter.vala"
		_tmp18_ = _tmp17_;
#line 472 "../src/math-converter.vala"
		_g_object_unref0 (_tmp15_);
#line 472 "../src/math-converter.vala"
		result = _tmp18_;
#line 472 "../src/math-converter.vala"
		_g_object_unref0 (number);
#line 472 "../src/math-converter.vala"
		return result;
#line 3662 "math-converter.c"
	}
#line 474 "../src/math-converter.vala"
	_tmp19_ = self->priv->fixed_serializer;
#line 474 "../src/math-converter.vala"
	_tmp20_ = serializer_from_string (_tmp19_, str);
#line 474 "../src/math-converter.vala"
	result = _tmp20_;
#line 474 "../src/math-converter.vala"
	return result;
#line 3672 "math-converter.c"
}

static gboolean
math_converter_key_press_cb (MathConverter* self,
                             GtkEventControllerKey* controller,
                             guint keyval,
                             guint keycode,
                             GdkModifierType mod_state)
{
	GdkModifierType state = 0U;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	guint new_keyval = 0U;
	guint32 c = 0U;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean result;
#line 478 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 478 "../src/math-converter.vala"
	g_return_val_if_fail (controller != NULL, FALSE);
#line 481 "../src/math-converter.vala"
	state = mod_state & (GDK_CONTROL_MASK | GDK_ALT_MASK);
#line 483 "../src/math-converter.vala"
	if (keyval == GDK_KEY_Escape) {
#line 483 "../src/math-converter.vala"
		_tmp1_ = state == 0;
#line 3704 "math-converter.c"
	} else {
#line 483 "../src/math-converter.vala"
		_tmp1_ = FALSE;
#line 3708 "math-converter.c"
	}
#line 483 "../src/math-converter.vala"
	if (_tmp1_) {
#line 483 "../src/math-converter.vala"
		_tmp0_ = TRUE;
#line 3714 "math-converter.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 484 "../src/math-converter.vala"
		if (keyval == GDK_KEY_Delete) {
#line 484 "../src/math-converter.vala"
			_tmp2_ = (mod_state & GDK_CONTROL_MASK) == GDK_CONTROL_MASK;
#line 3721 "math-converter.c"
		} else {
#line 484 "../src/math-converter.vala"
			_tmp2_ = FALSE;
#line 3725 "math-converter.c"
		}
#line 484 "../src/math-converter.vala"
		_tmp0_ = _tmp2_;
#line 3729 "math-converter.c"
	}
#line 483 "../src/math-converter.vala"
	if (_tmp0_) {
#line 486 "../src/math-converter.vala"
		math_converter_clear (self);
#line 487 "../src/math-converter.vala"
		result = TRUE;
#line 487 "../src/math-converter.vala"
		return result;
#line 3739 "math-converter.c"
	}
#line 491 "../src/math-converter.vala"
	new_keyval = (guint) 0;
#line 492 "../src/math-converter.vala"
	switch (keyval) {
#line 492 "../src/math-converter.vala"
		case GDK_KEY_KP_Insert:
#line 3747 "math-converter.c"
		{
#line 495 "../src/math-converter.vala"
			new_keyval = GDK_KEY_0;
#line 496 "../src/math-converter.vala"
			break;
#line 3753 "math-converter.c"
		}
#line 492 "../src/math-converter.vala"
		case GDK_KEY_KP_End:
#line 3757 "math-converter.c"
		{
#line 498 "../src/math-converter.vala"
			new_keyval = GDK_KEY_1;
#line 499 "../src/math-converter.vala"
			break;
#line 3763 "math-converter.c"
		}
#line 492 "../src/math-converter.vala"
		case GDK_KEY_KP_Down:
#line 3767 "math-converter.c"
		{
#line 501 "../src/math-converter.vala"
			new_keyval = GDK_KEY_2;
#line 502 "../src/math-converter.vala"
			break;
#line 3773 "math-converter.c"
		}
#line 492 "../src/math-converter.vala"
		case GDK_KEY_KP_Page_Down:
#line 3777 "math-converter.c"
		{
#line 504 "../src/math-converter.vala"
			new_keyval = GDK_KEY_3;
#line 505 "../src/math-converter.vala"
			break;
#line 3783 "math-converter.c"
		}
#line 492 "../src/math-converter.vala"
		case GDK_KEY_KP_Left:
#line 3787 "math-converter.c"
		{
#line 507 "../src/math-converter.vala"
			new_keyval = GDK_KEY_4;
#line 508 "../src/math-converter.vala"
			break;
#line 3793 "math-converter.c"
		}
#line 492 "../src/math-converter.vala"
		case GDK_KEY_KP_Begin:
#line 3797 "math-converter.c"
		{
#line 510 "../src/math-converter.vala"
			new_keyval = GDK_KEY_5;
#line 511 "../src/math-converter.vala"
			break;
#line 3803 "math-converter.c"
		}
#line 492 "../src/math-converter.vala"
		case GDK_KEY_KP_Right:
#line 3807 "math-converter.c"
		{
#line 513 "../src/math-converter.vala"
			new_keyval = GDK_KEY_6;
#line 514 "../src/math-converter.vala"
			break;
#line 3813 "math-converter.c"
		}
#line 492 "../src/math-converter.vala"
		case GDK_KEY_KP_Home:
#line 3817 "math-converter.c"
		{
#line 516 "../src/math-converter.vala"
			new_keyval = GDK_KEY_7;
#line 517 "../src/math-converter.vala"
			break;
#line 3823 "math-converter.c"
		}
#line 492 "../src/math-converter.vala"
		case GDK_KEY_KP_Up:
#line 3827 "math-converter.c"
		{
#line 519 "../src/math-converter.vala"
			new_keyval = GDK_KEY_8;
#line 520 "../src/math-converter.vala"
			break;
#line 3833 "math-converter.c"
		}
#line 492 "../src/math-converter.vala"
		case GDK_KEY_KP_Page_Up:
#line 3837 "math-converter.c"
		{
#line 522 "../src/math-converter.vala"
			new_keyval = GDK_KEY_9;
#line 523 "../src/math-converter.vala"
			break;
#line 3843 "math-converter.c"
		}
#line 492 "../src/math-converter.vala"
		case GDK_KEY_KP_Delete:
#line 3847 "math-converter.c"
		{
#line 525 "../src/math-converter.vala"
			new_keyval = GDK_KEY_period;
#line 526 "../src/math-converter.vala"
			break;
#line 3853 "math-converter.c"
		}
		default:
#line 492 "../src/math-converter.vala"
		break;
#line 3858 "math-converter.c"
	}
#line 529 "../src/math-converter.vala"
	if (new_keyval != ((guint) 0)) {
#line 531 "../src/math-converter.vala"
		g_info ("math-converter.vala:531: forwarding\n");
#line 532 "../src/math-converter.vala"
		result = math_converter_key_press_cb (self, controller, new_keyval, keycode, mod_state);
#line 532 "../src/math-converter.vala"
		return result;
#line 3868 "math-converter.c"
	}
#line 535 "../src/math-converter.vala"
	c = gdk_keyval_to_unicode (keyval);
#line 537 "../src/math-converter.vala"
	if (keyval == GDK_KEY_Return) {
#line 537 "../src/math-converter.vala"
		_tmp3_ = TRUE;
#line 3876 "math-converter.c"
	} else {
#line 537 "../src/math-converter.vala"
		_tmp3_ = keyval == GDK_KEY_KP_Enter;
#line 3880 "math-converter.c"
	}
#line 537 "../src/math-converter.vala"
	if (_tmp3_) {
#line 538 "../src/math-converter.vala"
		result = TRUE;
#line 538 "../src/math-converter.vala"
		return result;
#line 3888 "math-converter.c"
	}
#line 541 "../src/math-converter.vala"
	if (keyval == GDK_KEY_KP_Decimal) {
#line 541 "../src/math-converter.vala"
		_tmp7_ = TRUE;
#line 3894 "math-converter.c"
	} else {
#line 542 "../src/math-converter.vala"
		_tmp7_ = keyval == GDK_KEY_KP_Separator;
#line 3898 "math-converter.c"
	}
#line 541 "../src/math-converter.vala"
	if (_tmp7_) {
#line 541 "../src/math-converter.vala"
		_tmp6_ = TRUE;
#line 3904 "math-converter.c"
	} else {
#line 543 "../src/math-converter.vala"
		_tmp6_ = keyval == GDK_KEY_period;
#line 3908 "math-converter.c"
	}
#line 541 "../src/math-converter.vala"
	if (_tmp6_) {
#line 541 "../src/math-converter.vala"
		_tmp5_ = TRUE;
#line 3914 "math-converter.c"
	} else {
#line 544 "../src/math-converter.vala"
		_tmp5_ = keyval == GDK_KEY_decimalpoint;
#line 3918 "math-converter.c"
	}
#line 541 "../src/math-converter.vala"
	if (_tmp5_) {
#line 541 "../src/math-converter.vala"
		_tmp4_ = TRUE;
#line 3924 "math-converter.c"
	} else {
#line 545 "../src/math-converter.vala"
		_tmp4_ = keyval == GDK_KEY_comma;
#line 3928 "math-converter.c"
	}
#line 541 "../src/math-converter.vala"
	if (_tmp4_) {
#line 547 "../src/math-converter.vala"
		math_converter_insert_numeric_point (self);
#line 548 "../src/math-converter.vala"
		result = TRUE;
#line 548 "../src/math-converter.vala"
		return result;
#line 3938 "math-converter.c"
	}
#line 552 "../src/math-converter.vala"
	if (state == 0) {
#line 3942 "math-converter.c"
		gboolean _tmp8_ = FALSE;
#line 554 "../src/math-converter.vala"
		if (c >= ((guint32) '0')) {
#line 554 "../src/math-converter.vala"
			_tmp8_ = c <= ((guint32) '9');
#line 3948 "math-converter.c"
		} else {
#line 554 "../src/math-converter.vala"
			_tmp8_ = FALSE;
#line 3952 "math-converter.c"
		}
#line 554 "../src/math-converter.vala"
		if (_tmp8_) {
#line 3956 "math-converter.c"
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 556 "../src/math-converter.vala"
			_tmp9_ = g_strdup_printf ("%c", c);
#line 556 "../src/math-converter.vala"
			_tmp10_ = _tmp9_;
#line 556 "../src/math-converter.vala"
			math_converter_insert_text (self, _tmp10_);
#line 556 "../src/math-converter.vala"
			_g_free0 (_tmp10_);
#line 557 "../src/math-converter.vala"
			result = TRUE;
#line 557 "../src/math-converter.vala"
			return result;
#line 3971 "math-converter.c"
		}
#line 559 "../src/math-converter.vala"
		if (c == ((guint32) '-')) {
#line 561 "../src/math-converter.vala"
			math_converter_insert_text (self, "−");
#line 562 "../src/math-converter.vala"
			result = TRUE;
#line 562 "../src/math-converter.vala"
			return result;
#line 3981 "math-converter.c"
		}
	}
#line 567 "../src/math-converter.vala"
	if (state == GDK_CONTROL_MASK) {
#line 567 "../src/math-converter.vala"
		_tmp11_ = keyval == GDK_KEY_p;
#line 3988 "math-converter.c"
	} else {
#line 567 "../src/math-converter.vala"
		_tmp11_ = FALSE;
#line 3992 "math-converter.c"
	}
#line 567 "../src/math-converter.vala"
	if (_tmp11_) {
#line 569 "../src/math-converter.vala"
		math_converter_insert_text (self, "π");
#line 570 "../src/math-converter.vala"
		result = TRUE;
#line 570 "../src/math-converter.vala"
		return result;
#line 4002 "math-converter.c"
	}
#line 573 "../src/math-converter.vala"
	result = FALSE;
#line 573 "../src/math-converter.vala"
	return result;
#line 4008 "math-converter.c"
}

static gboolean
_math_converter_key_press_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                   guint keyval,
                                                                   guint keycode,
                                                                   GdkModifierType state,
                                                                   gpointer self)
{
	gboolean result;
	result = math_converter_key_press_cb ((MathConverter*) self, _sender, keyval, keycode, state);
#line 12 "../src/math-converter.vala"
	return result;
#line 4022 "math-converter.c"
}

static gpointer
_gdk_event_ref0 (gpointer self)
{
#line 579 "../src/math-converter.vala"
	return self ? gdk_event_ref (self) : NULL;
#line 4030 "math-converter.c"
}

static void
_vala_GdkEventSequence_free (GdkEventSequence* self)
{
#line 579 "../src/math-converter.vala"
	g_boxed_free (gdk_event_sequence_get_type (), self);
#line 4038 "math-converter.c"
}

static void
math_converter_from_entry_click_cb (MathConverter* self,
                                    GtkGestureClick* gesture,
                                    gint n_click,
                                    gdouble x,
                                    gdouble y)
{
	GdkEvent* event = NULL;
	GdkEventSequence* _tmp0_;
	GdkEventSequence* _tmp1_;
	GdkEvent* _tmp2_;
	GdkEvent* _tmp3_;
	GdkEvent* _tmp4_;
	GdkEvent* _tmp5_;
#line 577 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 577 "../src/math-converter.vala"
	g_return_if_fail (gesture != NULL);
#line 579 "../src/math-converter.vala"
	_tmp0_ = gtk_gesture_single_get_current_sequence ((GtkGestureSingle*) gesture);
#line 579 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 579 "../src/math-converter.vala"
	_tmp2_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, _tmp1_);
#line 579 "../src/math-converter.vala"
	_tmp3_ = _gdk_event_ref0 (_tmp2_);
#line 579 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 579 "../src/math-converter.vala"
	__vala_GdkEventSequence_free0 (_tmp1_);
#line 579 "../src/math-converter.vala"
	event = _tmp4_;
#line 580 "../src/math-converter.vala"
	_tmp5_ = event;
#line 580 "../src/math-converter.vala"
	if (gdk_event_triggers_context_menu (_tmp5_)) {
#line 4077 "math-converter.c"
		GtkTextView* _tmp6_;
#line 582 "../src/math-converter.vala"
		_tmp6_ = self->priv->from_entry;
#line 582 "../src/math-converter.vala"
		math_converter_show_context_menu (self, _tmp6_, x, y);
#line 583 "../src/math-converter.vala"
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 4085 "math-converter.c"
	}
#line 577 "../src/math-converter.vala"
	_gdk_event_unref0 (event);
#line 4089 "math-converter.c"
}

static void
_math_converter_from_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                               gint n_press,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_from_entry_click_cb ((MathConverter*) self, _sender, n_press, x, y);
#line 4101 "math-converter.c"
}

static void
math_converter_to_entry_click_cb (MathConverter* self,
                                  GtkGestureClick* gesture,
                                  gint n_click,
                                  gdouble x,
                                  gdouble y)
{
	GdkEvent* event = NULL;
	GdkEventSequence* _tmp0_;
	GdkEventSequence* _tmp1_;
	GdkEvent* _tmp2_;
	GdkEvent* _tmp3_;
	GdkEvent* _tmp4_;
	GdkEvent* _tmp5_;
#line 588 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 588 "../src/math-converter.vala"
	g_return_if_fail (gesture != NULL);
#line 590 "../src/math-converter.vala"
	_tmp0_ = gtk_gesture_single_get_current_sequence ((GtkGestureSingle*) gesture);
#line 590 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 590 "../src/math-converter.vala"
	_tmp2_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, _tmp1_);
#line 590 "../src/math-converter.vala"
	_tmp3_ = _gdk_event_ref0 (_tmp2_);
#line 590 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 590 "../src/math-converter.vala"
	__vala_GdkEventSequence_free0 (_tmp1_);
#line 590 "../src/math-converter.vala"
	event = _tmp4_;
#line 591 "../src/math-converter.vala"
	_tmp5_ = event;
#line 591 "../src/math-converter.vala"
	if (gdk_event_triggers_context_menu (_tmp5_)) {
#line 4140 "math-converter.c"
		GtkTextView* _tmp6_;
#line 593 "../src/math-converter.vala"
		_tmp6_ = self->priv->to_entry;
#line 593 "../src/math-converter.vala"
		math_converter_show_context_menu (self, _tmp6_, x, y);
#line 594 "../src/math-converter.vala"
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 4148 "math-converter.c"
	}
#line 588 "../src/math-converter.vala"
	_gdk_event_unref0 (event);
#line 4152 "math-converter.c"
}

static void
_math_converter_to_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                             gint n_press,
                                                             gdouble x,
                                                             gdouble y,
                                                             gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_to_entry_click_cb ((MathConverter*) self, _sender, n_press, x, y);
#line 4164 "math-converter.c"
}

static void
math_converter_show_context_menu (MathConverter* self,
                                  GtkTextView* entry,
                                  gdouble x,
                                  gdouble y)
{
	GdkClipboard* clipboard = NULL;
	GdkDisplay* _tmp0_;
	GdkClipboard* _tmp1_;
	GdkClipboard* _tmp2_;
	gboolean can_paste = FALSE;
	GdkClipboard* _tmp3_;
	GdkContentFormats* _tmp4_;
	GtkRoot* _tmp5_;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextBuffer* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextIter _tmp8_ = {0};
	GtkTextIter _tmp9_ = {0};
	GtkTextBuffer* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextIter _tmp12_;
	GtkTextIter _tmp13_;
	GtkPopoverMenu* _tmp14_ = NULL;
	GtkTextView* _tmp15_;
	GtkPopoverMenu* context_menu = NULL;
	GtkPopoverMenu* _tmp18_;
	gboolean _tmp19_ = FALSE;
	GtkPopoverMenu* _tmp23_;
#line 598 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 598 "../src/math-converter.vala"
	g_return_if_fail (entry != NULL);
#line 600 "../src/math-converter.vala"
	_tmp0_ = gdk_display_get_default ();
#line 600 "../src/math-converter.vala"
	_tmp1_ = gdk_display_get_clipboard (_tmp0_);
#line 600 "../src/math-converter.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 600 "../src/math-converter.vala"
	clipboard = _tmp2_;
#line 601 "../src/math-converter.vala"
	_tmp3_ = clipboard;
#line 601 "../src/math-converter.vala"
	_tmp4_ = gdk_clipboard_get_formats (_tmp3_);
#line 601 "../src/math-converter.vala"
	can_paste = gdk_content_formats_contain_gtype (_tmp4_, G_TYPE_STRING);
#line 602 "../src/math-converter.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "context-menu.paste", can_paste);
#line 603 "../src/math-converter.vala"
	_tmp5_ = gtk_widget_get_root ((GtkWidget*) self);
#line 603 "../src/math-converter.vala"
	gtk_root_set_focus (_tmp5_, NULL);
#line 605 "../src/math-converter.vala"
	_tmp6_ = gtk_text_view_get_buffer (entry);
#line 605 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 605 "../src/math-converter.vala"
	gtk_text_buffer_get_bounds (_tmp7_, &_tmp8_, &_tmp9_);
#line 605 "../src/math-converter.vala"
	start = _tmp8_;
#line 605 "../src/math-converter.vala"
	end = _tmp9_;
#line 606 "../src/math-converter.vala"
	_tmp10_ = gtk_text_view_get_buffer (entry);
#line 606 "../src/math-converter.vala"
	_tmp11_ = _tmp10_;
#line 606 "../src/math-converter.vala"
	_tmp12_ = start;
#line 606 "../src/math-converter.vala"
	_tmp13_ = end;
#line 606 "../src/math-converter.vala"
	gtk_text_buffer_select_range (_tmp11_, &_tmp12_, &_tmp13_);
#line 607 "../src/math-converter.vala"
	_tmp15_ = self->priv->from_entry;
#line 607 "../src/math-converter.vala"
	if (entry == _tmp15_) {
#line 4245 "math-converter.c"
		GtkPopoverMenu* _tmp16_;
#line 607 "../src/math-converter.vala"
		_tmp16_ = self->priv->from_context_menu;
#line 607 "../src/math-converter.vala"
		_tmp14_ = _tmp16_;
#line 4251 "math-converter.c"
	} else {
		GtkPopoverMenu* _tmp17_;
#line 607 "../src/math-converter.vala"
		_tmp17_ = self->priv->to_context_menu;
#line 607 "../src/math-converter.vala"
		_tmp14_ = _tmp17_;
#line 4258 "math-converter.c"
	}
#line 607 "../src/math-converter.vala"
	_tmp18_ = _g_object_ref0 (_tmp14_);
#line 607 "../src/math-converter.vala"
	context_menu = _tmp18_;
#line 608 "../src/math-converter.vala"
	if (x != ((gdouble) -1)) {
#line 608 "../src/math-converter.vala"
		_tmp19_ = y != ((gdouble) -1);
#line 4268 "math-converter.c"
	} else {
#line 608 "../src/math-converter.vala"
		_tmp19_ = FALSE;
#line 4272 "math-converter.c"
	}
#line 608 "../src/math-converter.vala"
	if (_tmp19_) {
#line 4276 "math-converter.c"
		GtkPopoverMenu* _tmp20_;
		GdkRectangle _tmp21_ = {0};
#line 609 "../src/math-converter.vala"
		_tmp20_ = context_menu;
#line 609 "../src/math-converter.vala"
		_tmp21_.x = (gint) x;
#line 609 "../src/math-converter.vala"
		_tmp21_.y = (gint) y;
#line 609 "../src/math-converter.vala"
		_tmp21_.width = 1;
#line 609 "../src/math-converter.vala"
		_tmp21_.height = 1;
#line 609 "../src/math-converter.vala"
		gtk_popover_set_pointing_to ((GtkPopover*) _tmp20_, &_tmp21_);
#line 4291 "math-converter.c"
	} else {
		GtkPopoverMenu* _tmp22_;
#line 611 "../src/math-converter.vala"
		_tmp22_ = context_menu;
#line 611 "../src/math-converter.vala"
		gtk_popover_set_pointing_to ((GtkPopover*) _tmp22_, NULL);
#line 4298 "math-converter.c"
	}
#line 612 "../src/math-converter.vala"
	_tmp23_ = context_menu;
#line 612 "../src/math-converter.vala"
	gtk_popover_popup ((GtkPopover*) _tmp23_);
#line 598 "../src/math-converter.vala"
	_g_object_unref0 (context_menu);
#line 598 "../src/math-converter.vala"
	_g_object_unref0 (clipboard);
#line 4308 "math-converter.c"
}

static void
math_converter_popup_cb (MathConverter* self,
                         GSimpleAction* action,
                         GVariant* param)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
#line 615 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 615 "../src/math-converter.vala"
	g_return_if_fail (action != NULL);
#line 617 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 617 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 617 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 617 "../src/math-converter.vala"
	if (_tmp3_) {
#line 4334 "math-converter.c"
		GtkTextView* _tmp4_;
#line 617 "../src/math-converter.vala"
		_tmp4_ = self->priv->from_entry;
#line 617 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 4340 "math-converter.c"
	} else {
		GtkTextView* _tmp5_;
#line 617 "../src/math-converter.vala"
		_tmp5_ = self->priv->to_entry;
#line 617 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 4347 "math-converter.c"
	}
#line 617 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 617 "../src/math-converter.vala"
	entry = _tmp6_;
#line 618 "../src/math-converter.vala"
	math_converter_show_context_menu (self, entry, (gdouble) -1, (gdouble) -1);
#line 615 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 4357 "math-converter.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 4379 "math-converter.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 4383 "math-converter.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 4389 "math-converter.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 4393 "math-converter.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 4397 "math-converter.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 4405 "math-converter.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4433 "math-converter.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 4442 "math-converter.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4456 "math-converter.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 4465 "math-converter.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 4479 "math-converter.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 4488 "math-converter.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 4497 "math-converter.c"
}

static void
math_converter_copy_cb (MathConverter* self,
                        GSimpleAction* action,
                        GVariant* param)
{
	Number* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	Number* number = NULL;
	Number* _tmp6_;
	gchar* text = NULL;
	MathEquation* _tmp7_;
	Serializer* _tmp8_;
	Serializer* _tmp9_;
	Number* _tmp10_;
	gchar* _tmp11_;
	gchar* tsep_string = NULL;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp15_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	GdkClipboard* clipboard = NULL;
	GdkDisplay* _tmp21_;
	GdkClipboard* _tmp22_;
	GdkClipboard* _tmp23_;
	const gchar* _tmp24_;
	GtkRoot* _tmp25_;
#line 621 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 621 "../src/math-converter.vala"
	g_return_if_fail (action != NULL);
#line 623 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 623 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 623 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 623 "../src/math-converter.vala"
	if (_tmp3_) {
#line 4543 "math-converter.c"
		Number* _tmp4_;
#line 623 "../src/math-converter.vala"
		_tmp4_ = self->priv->from_number;
#line 623 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 4549 "math-converter.c"
	} else {
		Number* _tmp5_;
#line 623 "../src/math-converter.vala"
		_tmp5_ = self->priv->to_number;
#line 623 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 4556 "math-converter.c"
	}
#line 623 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 623 "../src/math-converter.vala"
	number = _tmp6_;
#line 624 "../src/math-converter.vala"
	_tmp7_ = self->priv->_equation;
#line 624 "../src/math-converter.vala"
	_tmp8_ = math_equation_get_serializer (_tmp7_);
#line 624 "../src/math-converter.vala"
	_tmp9_ = _tmp8_;
#line 624 "../src/math-converter.vala"
	_tmp10_ = number;
#line 624 "../src/math-converter.vala"
	_tmp11_ = serializer_to_string (_tmp9_, _tmp10_);
#line 624 "../src/math-converter.vala"
	text = _tmp11_;
#line 625 "../src/math-converter.vala"
	_tmp12_ = nl_langinfo (THOUSEP);
#line 625 "../src/math-converter.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 625 "../src/math-converter.vala"
	tsep_string = _tmp13_;
#line 626 "../src/math-converter.vala"
	_tmp15_ = tsep_string;
#line 626 "../src/math-converter.vala"
	if (_tmp15_ == NULL) {
#line 626 "../src/math-converter.vala"
		_tmp14_ = TRUE;
#line 4586 "math-converter.c"
	} else {
		const gchar* _tmp16_;
#line 626 "../src/math-converter.vala"
		_tmp16_ = tsep_string;
#line 626 "../src/math-converter.vala"
		_tmp14_ = g_strcmp0 (_tmp16_, "") == 0;
#line 4593 "math-converter.c"
	}
#line 626 "../src/math-converter.vala"
	if (_tmp14_) {
#line 4597 "math-converter.c"
		gchar* _tmp17_;
#line 627 "../src/math-converter.vala"
		_tmp17_ = g_strdup (" ");
#line 627 "../src/math-converter.vala"
		_g_free0 (tsep_string);
#line 627 "../src/math-converter.vala"
		tsep_string = _tmp17_;
#line 4605 "math-converter.c"
	}
#line 628 "../src/math-converter.vala"
	_tmp18_ = text;
#line 628 "../src/math-converter.vala"
	_tmp19_ = tsep_string;
#line 628 "../src/math-converter.vala"
	_tmp20_ = string_replace (_tmp18_, _tmp19_, "");
#line 628 "../src/math-converter.vala"
	_g_free0 (text);
#line 628 "../src/math-converter.vala"
	text = _tmp20_;
#line 629 "../src/math-converter.vala"
	_tmp21_ = gdk_display_get_default ();
#line 629 "../src/math-converter.vala"
	_tmp22_ = gdk_display_get_clipboard (_tmp21_);
#line 629 "../src/math-converter.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 629 "../src/math-converter.vala"
	clipboard = _tmp23_;
#line 630 "../src/math-converter.vala"
	_tmp24_ = text;
#line 630 "../src/math-converter.vala"
	gdk_clipboard_set_text (clipboard, _tmp24_);
#line 631 "../src/math-converter.vala"
	_tmp25_ = gtk_widget_get_root ((GtkWidget*) self);
#line 631 "../src/math-converter.vala"
	gtk_root_set_focus (_tmp25_, NULL);
#line 621 "../src/math-converter.vala"
	_g_object_unref0 (clipboard);
#line 621 "../src/math-converter.vala"
	_g_free0 (tsep_string);
#line 621 "../src/math-converter.vala"
	_g_free0 (text);
#line 621 "../src/math-converter.vala"
	_g_object_unref0 (number);
#line 4641 "math-converter.c"
}

static void
math_converter_paste_cb (MathConverter* self,
                         GSimpleAction* action,
                         GVariant* param)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextBuffer* _tmp8_;
#line 634 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 634 "../src/math-converter.vala"
	g_return_if_fail (action != NULL);
#line 636 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 636 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 636 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 636 "../src/math-converter.vala"
	if (_tmp3_) {
#line 4669 "math-converter.c"
		GtkTextView* _tmp4_;
#line 636 "../src/math-converter.vala"
		_tmp4_ = self->priv->from_entry;
#line 636 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 4675 "math-converter.c"
	} else {
		GtkTextView* _tmp5_;
#line 636 "../src/math-converter.vala"
		_tmp5_ = self->priv->to_entry;
#line 636 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 4682 "math-converter.c"
	}
#line 636 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 636 "../src/math-converter.vala"
	entry = _tmp6_;
#line 637 "../src/math-converter.vala"
	_tmp7_ = gtk_text_view_get_buffer (entry);
#line 637 "../src/math-converter.vala"
	_tmp8_ = _tmp7_;
#line 637 "../src/math-converter.vala"
	g_object_set (_tmp8_, "text", "", NULL);
#line 638 "../src/math-converter.vala"
	math_converter_paste (self);
#line 634 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 4698 "math-converter.c"
}

static void
math_converter_reformat_display (MathConverter* self)
{
	Serializer* _tmp0_;
	MathEquation* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkTextView* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GtkTextView* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
#line 641 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 643 "../src/math-converter.vala"
	_tmp0_ = self->priv->fixed_serializer;
#line 643 "../src/math-converter.vala"
	_tmp1_ = self->priv->_equation;
#line 643 "../src/math-converter.vala"
	_tmp2_ = math_equation_get_accuracy (_tmp1_);
#line 643 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 643 "../src/math-converter.vala"
	if (serializer_get_trailing_digits (_tmp0_) != _tmp3_) {
#line 4726 "math-converter.c"
		Serializer* _tmp4_;
		MathEquation* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 644 "../src/math-converter.vala"
		_tmp4_ = self->priv->fixed_serializer;
#line 644 "../src/math-converter.vala"
		_tmp5_ = self->priv->_equation;
#line 644 "../src/math-converter.vala"
		_tmp6_ = math_equation_get_accuracy (_tmp5_);
#line 644 "../src/math-converter.vala"
		_tmp7_ = _tmp6_;
#line 644 "../src/math-converter.vala"
		serializer_set_trailing_digits (_tmp4_, _tmp7_);
#line 4741 "math-converter.c"
	}
#line 645 "../src/math-converter.vala"
	_tmp8_ = self->priv->from_entry;
#line 645 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp8_, "has-focus", &_tmp9_, NULL);
#line 645 "../src/math-converter.vala"
	_tmp10_ = _tmp9_;
#line 645 "../src/math-converter.vala"
	if (!_tmp10_) {
#line 4751 "math-converter.c"
		GtkTextView* _tmp11_;
		GtkTextBuffer* _tmp12_;
		GtkTextBuffer* _tmp13_;
		GtkTextView* _tmp14_;
		GtkTextBuffer* _tmp15_;
		GtkTextBuffer* _tmp16_;
		MathEquation* _tmp17_;
		Serializer* _tmp18_;
		Serializer* _tmp19_;
		Number* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		GtkTextView* _tmp23_;
		GtkTextBuffer* _tmp24_;
		GtkTextBuffer* _tmp25_;
#line 647 "../src/math-converter.vala"
		_tmp11_ = self->priv->from_entry;
#line 647 "../src/math-converter.vala"
		_tmp12_ = gtk_text_view_get_buffer (_tmp11_);
#line 647 "../src/math-converter.vala"
		_tmp13_ = _tmp12_;
#line 647 "../src/math-converter.vala"
		g_signal_handler_block (_tmp13_, self->priv->from_entry_changed);
#line 648 "../src/math-converter.vala"
		_tmp14_ = self->priv->from_entry;
#line 648 "../src/math-converter.vala"
		_tmp15_ = gtk_text_view_get_buffer (_tmp14_);
#line 648 "../src/math-converter.vala"
		_tmp16_ = _tmp15_;
#line 648 "../src/math-converter.vala"
		_tmp17_ = self->priv->_equation;
#line 648 "../src/math-converter.vala"
		_tmp18_ = math_equation_get_serializer (_tmp17_);
#line 648 "../src/math-converter.vala"
		_tmp19_ = _tmp18_;
#line 648 "../src/math-converter.vala"
		_tmp20_ = self->priv->from_number;
#line 648 "../src/math-converter.vala"
		_tmp21_ = serializer_to_string (_tmp19_, _tmp20_);
#line 648 "../src/math-converter.vala"
		_tmp22_ = _tmp21_;
#line 648 "../src/math-converter.vala"
		g_object_set (_tmp16_, "text", _tmp22_, NULL);
#line 648 "../src/math-converter.vala"
		_g_free0 (_tmp22_);
#line 649 "../src/math-converter.vala"
		_tmp23_ = self->priv->from_entry;
#line 649 "../src/math-converter.vala"
		_tmp24_ = gtk_text_view_get_buffer (_tmp23_);
#line 649 "../src/math-converter.vala"
		_tmp25_ = _tmp24_;
#line 649 "../src/math-converter.vala"
		g_signal_handler_unblock (_tmp25_, self->priv->from_entry_changed);
#line 4805 "math-converter.c"
	}
#line 651 "../src/math-converter.vala"
	_tmp26_ = self->priv->to_entry;
#line 651 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp26_, "has-focus", &_tmp27_, NULL);
#line 651 "../src/math-converter.vala"
	_tmp28_ = _tmp27_;
#line 651 "../src/math-converter.vala"
	if (!_tmp28_) {
#line 4815 "math-converter.c"
		GtkTextView* _tmp29_;
		GtkTextBuffer* _tmp30_;
		GtkTextBuffer* _tmp31_;
		GtkTextView* _tmp32_;
		GtkTextBuffer* _tmp33_;
		GtkTextBuffer* _tmp34_;
		MathEquation* _tmp35_;
		Serializer* _tmp36_;
		Serializer* _tmp37_;
		Number* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		GtkTextView* _tmp41_;
		GtkTextBuffer* _tmp42_;
		GtkTextBuffer* _tmp43_;
#line 653 "../src/math-converter.vala"
		_tmp29_ = self->priv->to_entry;
#line 653 "../src/math-converter.vala"
		_tmp30_ = gtk_text_view_get_buffer (_tmp29_);
#line 653 "../src/math-converter.vala"
		_tmp31_ = _tmp30_;
#line 653 "../src/math-converter.vala"
		g_signal_handler_block (_tmp31_, self->priv->to_entry_changed);
#line 654 "../src/math-converter.vala"
		_tmp32_ = self->priv->to_entry;
#line 654 "../src/math-converter.vala"
		_tmp33_ = gtk_text_view_get_buffer (_tmp32_);
#line 654 "../src/math-converter.vala"
		_tmp34_ = _tmp33_;
#line 654 "../src/math-converter.vala"
		_tmp35_ = self->priv->_equation;
#line 654 "../src/math-converter.vala"
		_tmp36_ = math_equation_get_serializer (_tmp35_);
#line 654 "../src/math-converter.vala"
		_tmp37_ = _tmp36_;
#line 654 "../src/math-converter.vala"
		_tmp38_ = self->priv->to_number;
#line 654 "../src/math-converter.vala"
		_tmp39_ = serializer_to_string (_tmp37_, _tmp38_);
#line 654 "../src/math-converter.vala"
		_tmp40_ = _tmp39_;
#line 654 "../src/math-converter.vala"
		g_object_set (_tmp34_, "text", _tmp40_, NULL);
#line 654 "../src/math-converter.vala"
		_g_free0 (_tmp40_);
#line 655 "../src/math-converter.vala"
		_tmp41_ = self->priv->to_entry;
#line 655 "../src/math-converter.vala"
		_tmp42_ = gtk_text_view_get_buffer (_tmp41_);
#line 655 "../src/math-converter.vala"
		_tmp43_ = _tmp42_;
#line 655 "../src/math-converter.vala"
		g_signal_handler_unblock (_tmp43_, self->priv->to_entry_changed);
#line 4869 "math-converter.c"
	}
}

static Number*
math_converter_convert_equation (MathConverter* self,
                                 Number* x,
                                 Unit** source_unit,
                                 Unit** target_unit)
{
	Unit* _vala_source_unit = NULL;
	Unit* _vala_target_unit = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GtkDropDown* _tmp2_;
	UnitCategory* category = NULL;
	GtkDropDown* _tmp5_;
	GObject* _tmp6_;
	GObject* _tmp7_;
	UnitCategory* _tmp8_;
	GtkDropDown* _tmp9_;
	GObject* _tmp10_;
	GObject* _tmp11_;
	Unit* _tmp12_;
	GtkDropDown* _tmp13_;
	GObject* _tmp14_;
	GObject* _tmp15_;
	Unit* _tmp16_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	UnitCategory* _tmp19_;
	Number* _tmp22_;
	Number* result;
#line 659 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 659 "../src/math-converter.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 663 "../src/math-converter.vala"
	_tmp2_ = self->priv->category_combo;
#line 663 "../src/math-converter.vala"
	if (_tmp2_ == NULL) {
#line 663 "../src/math-converter.vala"
		_tmp1_ = TRUE;
#line 4912 "math-converter.c"
	} else {
		GtkDropDown* _tmp3_;
#line 663 "../src/math-converter.vala"
		_tmp3_ = self->priv->from_combo;
#line 663 "../src/math-converter.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 4919 "math-converter.c"
	}
#line 663 "../src/math-converter.vala"
	if (_tmp1_) {
#line 663 "../src/math-converter.vala"
		_tmp0_ = TRUE;
#line 4925 "math-converter.c"
	} else {
		GtkDropDown* _tmp4_;
#line 663 "../src/math-converter.vala"
		_tmp4_ = self->priv->to_combo;
#line 663 "../src/math-converter.vala"
		_tmp0_ = _tmp4_ == NULL;
#line 4932 "math-converter.c"
	}
#line 663 "../src/math-converter.vala"
	if (_tmp0_) {
#line 664 "../src/math-converter.vala"
		result = NULL;
#line 664 "../src/math-converter.vala"
		if (source_unit) {
#line 664 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 4942 "math-converter.c"
		} else {
#line 664 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 4946 "math-converter.c"
		}
#line 664 "../src/math-converter.vala"
		if (target_unit) {
#line 664 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 4952 "math-converter.c"
		} else {
#line 664 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 4956 "math-converter.c"
		}
#line 664 "../src/math-converter.vala"
		return result;
#line 4960 "math-converter.c"
	}
#line 665 "../src/math-converter.vala"
	_tmp5_ = self->priv->category_combo;
#line 665 "../src/math-converter.vala"
	_tmp6_ = gtk_drop_down_get_selected_item (_tmp5_);
#line 665 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 665 "../src/math-converter.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) _tmp7_) : NULL);
#line 665 "../src/math-converter.vala"
	category = _tmp8_;
#line 666 "../src/math-converter.vala"
	_tmp9_ = self->priv->from_combo;
#line 666 "../src/math-converter.vala"
	_tmp10_ = gtk_drop_down_get_selected_item (_tmp9_);
#line 666 "../src/math-converter.vala"
	_tmp11_ = _tmp10_;
#line 666 "../src/math-converter.vala"
	_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, TYPE_UNIT) ? ((Unit*) _tmp11_) : NULL);
#line 666 "../src/math-converter.vala"
	_g_object_unref0 (_vala_source_unit);
#line 666 "../src/math-converter.vala"
	_vala_source_unit = _tmp12_;
#line 667 "../src/math-converter.vala"
	_tmp13_ = self->priv->to_combo;
#line 667 "../src/math-converter.vala"
	_tmp14_ = gtk_drop_down_get_selected_item (_tmp13_);
#line 667 "../src/math-converter.vala"
	_tmp15_ = _tmp14_;
#line 667 "../src/math-converter.vala"
	_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, TYPE_UNIT) ? ((Unit*) _tmp15_) : NULL);
#line 667 "../src/math-converter.vala"
	_g_object_unref0 (_vala_target_unit);
#line 667 "../src/math-converter.vala"
	_vala_target_unit = _tmp16_;
#line 669 "../src/math-converter.vala"
	_tmp19_ = category;
#line 669 "../src/math-converter.vala"
	if (_tmp19_ == NULL) {
#line 669 "../src/math-converter.vala"
		_tmp18_ = TRUE;
#line 5002 "math-converter.c"
	} else {
		Unit* _tmp20_;
#line 669 "../src/math-converter.vala"
		_tmp20_ = _vala_source_unit;
#line 669 "../src/math-converter.vala"
		_tmp18_ = _tmp20_ == NULL;
#line 5009 "math-converter.c"
	}
#line 669 "../src/math-converter.vala"
	if (_tmp18_) {
#line 669 "../src/math-converter.vala"
		_tmp17_ = TRUE;
#line 5015 "math-converter.c"
	} else {
		Unit* _tmp21_;
#line 669 "../src/math-converter.vala"
		_tmp21_ = _vala_target_unit;
#line 669 "../src/math-converter.vala"
		_tmp17_ = _tmp21_ == NULL;
#line 5022 "math-converter.c"
	}
#line 669 "../src/math-converter.vala"
	if (_tmp17_) {
#line 670 "../src/math-converter.vala"
		result = NULL;
#line 670 "../src/math-converter.vala"
		_g_object_unref0 (category);
#line 670 "../src/math-converter.vala"
		if (source_unit) {
#line 670 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 5034 "math-converter.c"
		} else {
#line 670 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 5038 "math-converter.c"
		}
#line 670 "../src/math-converter.vala"
		if (target_unit) {
#line 670 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 5044 "math-converter.c"
		} else {
#line 670 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 5048 "math-converter.c"
		}
#line 670 "../src/math-converter.vala"
		return result;
#line 5052 "math-converter.c"
	}
#line 671 "../src/math-converter.vala"
	_tmp22_ = self->priv->from_number;
#line 671 "../src/math-converter.vala"
	if (x == _tmp22_) {
#line 5058 "math-converter.c"
		UnitCategory* _tmp23_;
		Unit* _tmp24_;
		Unit* _tmp25_;
		Number* _tmp26_;
#line 672 "../src/math-converter.vala"
		_tmp23_ = category;
#line 672 "../src/math-converter.vala"
		_tmp24_ = _vala_source_unit;
#line 672 "../src/math-converter.vala"
		_tmp25_ = _vala_target_unit;
#line 672 "../src/math-converter.vala"
		_tmp26_ = unit_category_convert (_tmp23_, x, _tmp24_, _tmp25_);
#line 672 "../src/math-converter.vala"
		result = _tmp26_;
#line 672 "../src/math-converter.vala"
		_g_object_unref0 (category);
#line 672 "../src/math-converter.vala"
		if (source_unit) {
#line 672 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 5079 "math-converter.c"
		} else {
#line 672 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 5083 "math-converter.c"
		}
#line 672 "../src/math-converter.vala"
		if (target_unit) {
#line 672 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 5089 "math-converter.c"
		} else {
#line 672 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 5093 "math-converter.c"
		}
#line 672 "../src/math-converter.vala"
		return result;
#line 5097 "math-converter.c"
	} else {
		UnitCategory* _tmp27_;
		Unit* _tmp28_;
		Unit* _tmp29_;
		Number* _tmp30_;
#line 674 "../src/math-converter.vala"
		_tmp27_ = category;
#line 674 "../src/math-converter.vala"
		_tmp28_ = _vala_target_unit;
#line 674 "../src/math-converter.vala"
		_tmp29_ = _vala_source_unit;
#line 674 "../src/math-converter.vala"
		_tmp30_ = unit_category_convert (_tmp27_, x, _tmp28_, _tmp29_);
#line 674 "../src/math-converter.vala"
		result = _tmp30_;
#line 674 "../src/math-converter.vala"
		_g_object_unref0 (category);
#line 674 "../src/math-converter.vala"
		if (source_unit) {
#line 674 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 5119 "math-converter.c"
		} else {
#line 674 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 5123 "math-converter.c"
		}
#line 674 "../src/math-converter.vala"
		if (target_unit) {
#line 674 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 5129 "math-converter.c"
		} else {
#line 674 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 5133 "math-converter.c"
		}
#line 674 "../src/math-converter.vala"
		return result;
#line 5137 "math-converter.c"
	}
}

MathEquation*
math_converter_get_equation (MathConverter* self)
{
	MathEquation* result;
	MathEquation* _tmp0_;
#line 14 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 14 "../src/math-converter.vala"
	_tmp0_ = self->priv->_equation;
#line 14 "../src/math-converter.vala"
	result = _tmp0_;
#line 14 "../src/math-converter.vala"
	return result;
#line 5154 "math-converter.c"
}

void
math_converter_set_equation (MathConverter* self,
                             MathEquation* value)
{
	MathEquation* old_value;
#line 14 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 14 "../src/math-converter.vala"
	old_value = math_converter_get_equation (self);
#line 14 "../src/math-converter.vala"
	if (old_value != value) {
#line 5168 "math-converter.c"
		MathEquation* _tmp0_;
#line 14 "../src/math-converter.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 14 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->_equation);
#line 14 "../src/math-converter.vala"
		self->priv->_equation = _tmp0_;
#line 14 "../src/math-converter.vala"
		g_object_notify_by_pspec ((GObject *) self, math_converter_properties[MATH_CONVERTER_EQUATION_PROPERTY]);
#line 5178 "math-converter.c"
	}
}

gboolean
math_converter_get_box_visible (MathConverter* self)
{
	gboolean result;
#line 51 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../src/math-converter.vala"
	result = self->priv->_box_visible;
#line 51 "../src/math-converter.vala"
	return result;
#line 5192 "math-converter.c"
}

void
math_converter_set_box_visible (MathConverter* self,
                                gboolean value)
{
	gboolean old_value;
#line 51 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/math-converter.vala"
	old_value = math_converter_get_box_visible (self);
#line 51 "../src/math-converter.vala"
	if (old_value != value) {
#line 51 "../src/math-converter.vala"
		self->priv->_box_visible = value;
#line 51 "../src/math-converter.vala"
		g_object_notify_by_pspec ((GObject *) self, math_converter_properties[MATH_CONVERTER_BOX_VISIBLE_PROPERTY]);
#line 5210 "math-converter.c"
	}
}

static void
_math_converter_construct_finish_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 68 "../src/math-converter.vala"
	math_converter_construct_finish ((MathConverter*) self);
#line 5221 "math-converter.c"
}

static GObject *
math_converter_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MathConverter * self;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
#line 64 "../src/math-converter.vala"
	parent_class = G_OBJECT_CLASS (math_converter_parent_class);
#line 64 "../src/math-converter.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 64 "../src/math-converter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_CONVERTER, MathConverter);
#line 66 "../src/math-converter.vala"
	_tmp0_ = self->priv->action_group;
#line 66 "../src/math-converter.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp0_, MATH_CONVERTER_action_entries, (gint) G_N_ELEMENTS (MATH_CONVERTER_action_entries), self);
#line 67 "../src/math-converter.vala"
	_tmp1_ = self->priv->action_group;
#line 67 "../src/math-converter.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "context-menu", (GActionGroup*) _tmp1_);
#line 68 "../src/math-converter.vala"
	g_signal_connect_object ((GObject*) self, "notify::equation", (GCallback) _math_converter_construct_finish_g_object_notify, self, 0);
#line 64 "../src/math-converter.vala"
	return obj;
#line 5252 "math-converter.c"
}

static void
math_converter_class_init (MathConverterClass * klass,
                           gpointer klass_data)
{
#line 12 "../src/math-converter.vala"
	math_converter_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/math-converter.vala"
	g_type_class_adjust_private_offset (klass, &MathConverter_private_offset);
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_math_converter_get_property;
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_math_converter_set_property;
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->constructor = math_converter_constructor;
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->finalize = math_converter_finalize;
#line 12 "../src/math-converter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_CONVERTER_EQUATION_PROPERTY, math_converter_properties[MATH_CONVERTER_EQUATION_PROPERTY] = g_param_spec_object ("equation", "equation", "equation", TYPE_MATH_EQUATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 12 "../src/math-converter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_CONVERTER_BOX_VISIBLE_PROPERTY, math_converter_properties[MATH_CONVERTER_BOX_VISIBLE_PROPERTY] = g_param_spec_boolean ("box-visible", "box-visible", "box-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/calculator/math-converter.ui");
#line 12 "../src/math-converter.vala"
	math_converter_signals[MATH_CONVERTER_CATEGORY_CHANGED_SIGNAL] = g_signal_new ("category-changed", TYPE_MATH_CONVERTER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "category_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, category_combo));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_combo));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_combo));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_entry", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_entry));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_entry", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_entry));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_context_menu", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_context_menu));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_context_menu", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_context_menu));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_event_controller", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_event_controller));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_event_controller", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_event_controller));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "category_combobox_changed_cb", G_CALLBACK(_math_converter_category_combobox_changed_cb_g_object_notify));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_combobox_changed_cb", G_CALLBACK(_math_converter_to_combobox_changed_cb_g_object_notify));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "from_entry_focus_cb", G_CALLBACK(_math_converter_from_entry_focus_cb_g_object_notify));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_entry_focus_cb", G_CALLBACK(_math_converter_to_entry_focus_cb_g_object_notify));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "key_press_cb", G_CALLBACK(_math_converter_key_press_cb_gtk_event_controller_key_key_pressed));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "from_entry_click_cb", G_CALLBACK(_math_converter_from_entry_click_cb_gtk_gesture_click_pressed));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_entry_click_cb", G_CALLBACK(_math_converter_to_entry_click_cb_gtk_gesture_click_pressed));
#line 56 "../src/math-converter.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "mathconverter");
#line 5313 "math-converter.c"
}

static void
math_converter_instance_init (MathConverter * self,
                              gpointer klass)
{
	GSimpleActionGroup* _tmp0_;
#line 12 "../src/math-converter.vala"
	self->priv = math_converter_get_instance_private (self);
#line 40 "../src/math-converter.vala"
	self->priv->from_combobox_changed = (gulong) 0;
#line 44 "../src/math-converter.vala"
	_tmp0_ = g_simple_action_group_new ();
#line 44 "../src/math-converter.vala"
	self->priv->action_group = _tmp0_;
#line 51 "../src/math-converter.vala"
	self->priv->_box_visible = FALSE;
#line 12 "../src/math-converter.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 5333 "math-converter.c"
}

static void
math_converter_finalize (GObject * obj)
{
	MathConverter * self;
#line 12 "../src/math-converter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_CONVERTER, MathConverter);
#line 14 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->_equation);
#line 16 "../src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 17 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 18 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 35 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->fixed_serializer);
#line 44 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->action_group);
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (math_converter_parent_class)->finalize (obj);
#line 5356 "math-converter.c"
}

static GType
math_converter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MathConverterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) math_converter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MathConverter), 0, (GInstanceInitFunc) math_converter_instance_init, NULL };
	GType math_converter_type_id;
	math_converter_type_id = g_type_register_static (gtk_box_get_type (), "MathConverter", &g_define_type_info, 0);
	MathConverter_private_offset = g_type_add_instance_private (math_converter_type_id, sizeof (MathConverterPrivate));
	return math_converter_type_id;
}

GType
math_converter_get_type (void)
{
	static volatile gsize math_converter_type_id__once = 0;
	if (g_once_init_enter (&math_converter_type_id__once)) {
		GType math_converter_type_id;
		math_converter_type_id = math_converter_get_type_once ();
		g_once_init_leave (&math_converter_type_id__once, math_converter_type_id);
	}
	return math_converter_type_id__once;
}

static void
_vala_math_converter_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	MathConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MATH_CONVERTER, MathConverter);
#line 12 "../src/math-converter.vala"
	switch (property_id) {
#line 12 "../src/math-converter.vala"
		case MATH_CONVERTER_EQUATION_PROPERTY:
#line 12 "../src/math-converter.vala"
		g_value_set_object (value, math_converter_get_equation (self));
#line 12 "../src/math-converter.vala"
		break;
#line 12 "../src/math-converter.vala"
		case MATH_CONVERTER_BOX_VISIBLE_PROPERTY:
#line 12 "../src/math-converter.vala"
		g_value_set_boolean (value, math_converter_get_box_visible (self));
#line 12 "../src/math-converter.vala"
		break;
#line 5403 "math-converter.c"
		default:
#line 12 "../src/math-converter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/math-converter.vala"
		break;
#line 5409 "math-converter.c"
	}
}

static void
_vala_math_converter_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	MathConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MATH_CONVERTER, MathConverter);
#line 12 "../src/math-converter.vala"
	switch (property_id) {
#line 12 "../src/math-converter.vala"
		case MATH_CONVERTER_EQUATION_PROPERTY:
#line 12 "../src/math-converter.vala"
		math_converter_set_equation (self, g_value_get_object (value));
#line 12 "../src/math-converter.vala"
		break;
#line 12 "../src/math-converter.vala"
		case MATH_CONVERTER_BOX_VISIBLE_PROPERTY:
#line 12 "../src/math-converter.vala"
		math_converter_set_box_visible (self, g_value_get_boolean (value));
#line 12 "../src/math-converter.vala"
		break;
#line 5435 "math-converter.c"
		default:
#line 12 "../src/math-converter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/math-converter.vala"
		break;
#line 5441 "math-converter.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

